'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var ClearIcon = require('@mui/icons-material/Clear');
var material = require('@mui/material');
var TextField = require('@mui/material/TextField');
var ArrowDropDownIcon = require('@mui/icons-material/ArrowDropDown');
var colors = require('@mui/material/colors');
var xDatePickers = require('@mui/x-date-pickers');
var AdapterDayjs = require('@mui/x-date-pickers/AdapterDayjs');
var iconsMaterial = require('@mui/icons-material');
var styles = require('@mui/material/styles');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var ClearIcon__default = /*#__PURE__*/_interopDefaultLegacy(ClearIcon);
var TextField__default = /*#__PURE__*/_interopDefaultLegacy(TextField);
var ArrowDropDownIcon__default = /*#__PURE__*/_interopDefaultLegacy(ArrowDropDownIcon);

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    if (typeof b !== "function" && b !== null)
        throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

function __spreadArray(to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
}

var selectFromObject = function (selector, data) {
    var regex = new RegExp('.*[.*=.*]');
    var splitSelector = selector.split('.');
    var workingObject = data;
    splitSelector.forEach(function (selectorItem) {
        if (!workingObject)
            workingObject = {};
        if (regex.test(selectorItem)) {
            var objectBeforeQuery = selectorItem.replace(/\[.*\]/g, '');
            if (objectBeforeQuery) {
                workingObject = workingObject[objectBeforeQuery];
            }
            if (!Array.isArray(workingObject))
                return false;
            var splitQuery = selectorItem.replace(/.*\[|\]/g, '').split('=');
            var queryKey_1 = splitQuery[0].trim();
            var queryValue_1 = isNaN(parseInt(splitQuery[1])) ? splitQuery[1] : parseInt(splitQuery[1]);
            workingObject = workingObject.find(function (ob) { return ob[queryKey_1] === queryValue_1; });
        }
        else {
            workingObject = workingObject[selectorItem];
        }
    });
    return workingObject;
};
var setToObject = function (selector, value, object) {
    // value = typeof value !== 'boolean' && !Array.isArray(value) && value && !isNaN(value) ? parseInt(value, 10) : value
    var regex = new RegExp('.*[.*=.*]');
    var splitSelector = selector.split('.');
    if (splitSelector.length > 1) {
        var workingObject_1 = object;
        splitSelector.forEach(function (selectorItem, index) {
            var _a;
            var isLast = splitSelector.length === index + 1;
            if (regex.test(selectorItem)) {
                var replacedSelectorItem = selectorItem.replace(/\[.*\]/, '');
                if (!workingObject_1.hasOwnProperty(replacedSelectorItem))
                    workingObject_1[replacedSelectorItem] = [];
                var splitQuery = selectorItem.replace(/.*\[|\]/g, '').split('=');
                var queryKey_2 = splitQuery[0].trim();
                var queryValue_2 = isNaN(parseInt(splitQuery[1])) ? splitQuery[1] : parseInt(splitQuery[1]);
                var exists = workingObject_1[replacedSelectorItem].find(function (item) { return item[queryKey_2] === queryValue_2; });
                if (exists) {
                    workingObject_1 = exists;
                }
                else {
                    var newObject = (_a = {}, _a[queryKey_2] = queryValue_2, _a);
                    workingObject_1[replacedSelectorItem].push(newObject);
                    workingObject_1 = newObject;
                }
            }
            else {
                if (isLast) {
                    workingObject_1[selectorItem] = value;
                }
                else {
                    if (!workingObject_1.hasOwnProperty(selectorItem))
                        workingObject_1[selectorItem] = {};
                    workingObject_1 = workingObject_1[selectorItem];
                }
            }
        });
    }
    else {
        object[selector] = value;
    }
    return object;
};

var randomString = function (length) {
    var result = '';
    var characters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
    var charactersLength = characters.length;
    for (var i = 0; i < length; i++) {
        result += characters.charAt(Math.floor(Math.random() * charactersLength));
    }
    return result;
};
var mask = function (value, pattern, placeholder) {
    if (placeholder === void 0) { placeholder = ''; }
    var i = 0, v = value.toString();
    return pattern.replace(/\./g, function (_) { return v[i++] || placeholder; });
};
var isNull = function (data) {
    return data === null;
};
var checkValue = function (value) {
    if (value === null)
        return false;
    if (value === undefined)
        return false;
    return true;
};

var LoadingComponent$1 = function (props) { return (React__default["default"].createElement(material.Grow, { in: true, timeout: 550 },
    React__default["default"].createElement(material.Box, { sx: { paddingRight: '8px', paddingTop: '4px' } },
        React__default["default"].createElement(material.CircularProgress, { size: 18 })))); };
var AutocompleteInput = /** @class */ (function (_super) {
    __extends(AutocompleteInput, _super);
    function AutocompleteInput() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            value: _this.getValuesFrom(_this.props.defaultValue || null),
            error: false
        };
        _this.onChange = function (_, option) {
            if (Array.isArray(option)) {
                _this.setValue(option.map(function (i) { return typeof i === "string" ? i : i.value; }));
            }
            else {
                _this.setValue(typeof option === "string" ? option : option.value);
            }
        };
        _this.onClick = function (event) {
            clearTimeout(_this.validationTimeout);
            _this.setState(__assign(__assign({}, _this.state), { error: false }));
        };
        _this.click = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.click();
        };
        _this.focus = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.focus();
        };
        _this.blur = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.blur();
        };
        _this.onInputBlur = function (event) {
            if (!_this.props.multiple && _this.props.freeSolo) {
                _this.setValue(event.target.value);
            }
        };
        return _this;
    }
    AutocompleteInput.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var _this = this;
        var _a, _b;
        switch (true) {
            case this.state.value !== nextState.value:
            case this.getValueForCheck(this.state.value || undefined) !== this.getValueForCheck(nextState.value || undefined):
            case this.state.error !== nextState.error:
            case ((_a = this.props.options) === null || _a === void 0 ? void 0 : _a.map(function (i) { return _this.optionGetter(i, 'value'); }).join('@')) !== ((_b = nextProps.options) === null || _b === void 0 ? void 0 : _b.map(function (i) { return _this.optionGetter(i, 'value'); }).join('@')):
            case this.props.loading !== nextProps.loading:
            case this.props.loadingText !== nextProps.loadingText:
            case this.props.label !== nextProps.label:
                return true;
            default: return false;
        }
    };
    AutocompleteInput.prototype.getValuesFrom = function (value) {
        var _this = this;
        if (!value)
            return null;
        if (this.props.multiple && !Array.isArray(value))
            return null;
        if (!this.props.multiple && Array.isArray(value))
            return null;
        if (this.props.freeSolo && !this.props.multiple) {
            var exists = this.props.options.find(function (i) { return (typeof i === "string" ? i : i.value) === value || (typeof i === "string" ? i : i.label) === value; });
            return exists || { label: (value === null || value === void 0 ? void 0 : value.toString()) || "", value: (value === null || value === void 0 ? void 0 : value.toString()) || "" };
        }
        if (this.props.freeSolo && this.props.multiple && typeof value === "object" && Array.isArray(value)) {
            var outputOptions = value.map(function (valueItem) {
                var exists = _this.props.options.find(function (i) { return (typeof i === "string" ? i : i.value) === valueItem; });
                return exists || { label: (valueItem === null || valueItem === void 0 ? void 0 : valueItem.toString().trim()) || "", value: (valueItem === null || valueItem === void 0 ? void 0 : valueItem.toString().trim()) || "" };
            });
            return outputOptions;
        }
        if (typeof value === "object" && Array.isArray(value)) {
            return this.props.options.filter(function (i) { return value.indexOf(typeof i === "string" ? i : i.value) > -1; });
        }
        else if (value) {
            return this.props.options.find(function (i) { return (typeof i === "string" ? i : i.value) === value; });
        }
        return undefined;
    };
    AutocompleteInput.prototype.componentDidUpdate = function (props) {
        var _this = this;
        var _a, _b;
        if (((_a = this.props.options) === null || _a === void 0 ? void 0 : _a.map(function (i) { return _this.optionGetter(i, 'value'); }).join('@')) !== ((_b = props.options) === null || _b === void 0 ? void 0 : _b.map(function (i) { return _this.optionGetter(i, 'value'); }).join('@'))) {
            this.clear();
        }
    };
    AutocompleteInput.prototype.setValue = function (value) {
        return __awaiter(this, void 0, void 0, function () {
            var valueToSet, setStatePromise;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        valueToSet = this.getValuesFrom(value);
                        return [4 /*yield*/, this.setState(__assign(__assign({}, this.state), { value: valueToSet }))];
                    case 1:
                        setStatePromise = _a.sent();
                        if (!(typeof this.props._call_parent_for_update === "function")) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.props._call_parent_for_update()];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        if (!(typeof this.props.onChangeValue === "function")) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.props.onChangeValue(value)];
                    case 4:
                        _a.sent();
                        _a.label = 5;
                    case 5: return [2 /*return*/, setStatePromise];
                }
            });
        });
    };
    AutocompleteInput.prototype.getValue = function () {
        var _a;
        return (Array.isArray(this.state.value)
            ? this.state.value.map(function (i) { return typeof i === "string" ? i : i.value; })
            : typeof this.state.value === "string" ? this.state.value : (_a = this.state.value) === null || _a === void 0 ? void 0 : _a.value) || (this.props.multiple ? [] : null);
    };
    AutocompleteInput.prototype.clear = function (withoutDefaults) {
        if (withoutDefaults === void 0) { withoutDefaults = false; }
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.setValue((!withoutDefaults ? this.props.defaultValue : null) || null)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    AutocompleteInput.prototype.validation = function () {
        var _this = this;
        if (!this.getValueForCheck(this.state.value) && this.props.required) {
            clearTimeout(this.validationTimeout);
            this.setState(__assign(__assign({}, this.state), { error: true }));
            this.validationTimeout = setTimeout(function () {
                _this.setState(__assign(__assign({}, _this.state), { error: false }));
            }, 3000);
            return false;
        }
        return true;
    };
    AutocompleteInput.prototype.optionGetter = function (item, selector) {
        var _a;
        if (selector === void 0) { selector = "value"; }
        return typeof item === "string" || typeof item === "number" || isNull(item) ? (item !== null && item !== void 0 ? item : "") : ((_a = item === null || item === void 0 ? void 0 : item[selector]) !== null && _a !== void 0 ? _a : "");
    };
    AutocompleteInput.prototype.getValueForCheck = function (value) {
        return !isNull(value) && Array.isArray(value) ? value.join('@') : value;
    };
    AutocompleteInput.prototype.render = function () {
        var _this = this;
        var _a = this.props; _a.defaultValue; _a.onChangeValue; var InputProps = _a.InputProps, renderInput = _a.renderInput, label = _a.label, placeholder = _a.placeholder, variant = _a.variant, required = _a.required; _a.visible; _a._call_parent_for_update; var restProps = __rest(_a, ["defaultValue", "onChangeValue", "InputProps", "renderInput", "label", "placeholder", "variant", "required", "visible", "_call_parent_for_update"]);
        var variantWidth = '207px';
        if (this.props.variant === "outlined")
            variantWidth = "235px";
        if (this.props.variant === "filled")
            variantWidth = "231px";
        var inputWidth = this.props.fullWidth ? '100%' : variantWidth;
        return (React__default["default"].createElement(material.Autocomplete, __assign({}, restProps, { sx: __assign({ width: inputWidth, display: 'inline-flex' }, this.props.sx), options: this.props.options, getOptionLabel: function (option) { return typeof option === "object" ? option.label : (option.toString()); }, multiple: this.props.multiple, freeSolo: this.props.freeSolo, onChange: this.onChange, disableClearable: true, size: this.props.size || !variant || variant === "standard" ? "small" : "medium", value: this.state.value || (this.props.multiple ? [] : (this.props.freeSolo ? "" : null)), disabled: this.props.disabled || this.props.loading, clearOnBlur: this.props.multiple || (this.props.multiple && this.props.freeSolo) || (!this.props.multiple && !this.props.freeSolo), popupIcon: this.props.loading ? React__default["default"].createElement(LoadingComponent$1, null) : (this.props.popupIcon || React__default["default"].createElement(ArrowDropDownIcon__default["default"], null)), isOptionEqualToValue: function (option, value) {
                if (!value)
                    return false;
                return typeof option === "string" ? option === (typeof value === "string" ? value : value.value.toString()) : option.value.toString() === (typeof value === "string" ? value : value.value.toString());
            }, renderInput: renderInput ? function (params) {
                params.inputRef = function (el) { return _this.inputRef = el; };
                params.error = _this.state.error;
                params.variant = variant || "standard";
                params.label = label;
                params.required = required;
                params.onClick = _this.onClick;
                return renderInput(params);
            } : (function (params) { return (React__default["default"].createElement(TextField__default["default"], __assign({}, params, InputProps, { label: label, placeholder: placeholder, variant: variant || "standard", required: required, onClick: _this.onClick, error: _this.state.error, inputRef: function (el) { return _this.inputRef = el; }, InputProps: __assign(__assign(__assign({}, InputProps === null || InputProps === void 0 ? void 0 : InputProps.InputProps), params.InputProps), { onBlur: _this.onInputBlur, endAdornment: (React__default["default"].createElement(material.InputAdornment, { position: "end" },
                        params.InputProps.endAdornment,
                        !_this.props.disableClearable && _this.getValueForCheck(_this.state.value) ? (React__default["default"].createElement(material.IconButton, { size: "small", onClick: function (e) {
                                e.stopPropagation();
                                _this.clear(true);
                            } },
                            React__default["default"].createElement(ClearIcon__default["default"], { fontSize: "small" }))) : null)) }) }))); }) })));
    };
    return AutocompleteInput;
}(React.Component));

var CheckboxInput = /** @class */ (function (_super) {
    __extends(CheckboxInput, _super);
    function CheckboxInput() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            value: _this.props.defaultChecked || false,
            error: false
        };
        _this.onChange = function (event) {
            _this.setValue(event.target.checked || false);
        };
        _this.onClick = function (event) {
            clearTimeout(_this.validationTimeout);
            _this.setState(__assign(__assign({}, _this.state), { error: false }));
        };
        _this.click = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.click();
        };
        _this.focus = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.focus();
        };
        _this.blur = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.blur();
        };
        return _this;
    }
    CheckboxInput.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        switch (true) {
            case this.state.value !== nextState.value:
            case this.state.error !== nextState.error:
            case this.props.label !== nextProps.label:
                return true;
            default: return false;
        }
    };
    CheckboxInput.prototype.setValue = function (value) {
        return __awaiter(this, void 0, void 0, function () {
            var setStatePromise;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (value === this.state.value)
                            return [2 /*return*/, Promise.resolve()];
                        return [4 /*yield*/, this.setState(__assign(__assign({}, this.state), { value: value }))];
                    case 1:
                        setStatePromise = _a.sent();
                        if (!(typeof this.props._call_parent_for_update === "function")) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.props._call_parent_for_update()];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        if (!(typeof this.props.onChangeValue === "function")) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.props.onChangeValue(value)];
                    case 4:
                        _a.sent();
                        _a.label = 5;
                    case 5: return [2 /*return*/, setStatePromise];
                }
            });
        });
    };
    CheckboxInput.prototype.getValue = function () {
        return this.state.value || false;
    };
    CheckboxInput.prototype.clear = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.setValue(this.props.checked || this.props.defaultChecked || false)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    CheckboxInput.prototype.validation = function () {
        var _this = this;
        if (!this.state.value && this.props.required) {
            clearTimeout(this.validationTimeout);
            this.setState(__assign(__assign({}, this.state), { error: true }));
            this.validationTimeout = setTimeout(function () {
                _this.setState(__assign(__assign({}, _this.state), { error: false }));
            }, 3000);
            return false;
        }
        return true;
    };
    CheckboxInput.prototype.render = function () {
        var _this = this;
        var _a = this.props; _a.defaultChecked; _a.defaultValue; _a.onChangeValue; _a.visible; _a._call_parent_for_update; var restProps = __rest(_a, ["defaultChecked", "defaultValue", "onChangeValue", "visible", "_call_parent_for_update"]);
        var label = this.props.label + (this.props.required ? ' *' : '');
        return (React__default["default"].createElement(material.FormControlLabel, { onClick: this.onClick, control: React__default["default"].createElement(material.Checkbox, __assign({}, restProps, { sx: { color: this.state.error ? colors.red[700] : colors.grey[700] }, checked: this.state.value, onChange: this.onChange, inputRef: function (el) { return _this.inputRef = el; } })), style: { userSelect: 'none' }, label: label }));
    };
    return CheckboxInput;
}(React.Component));

var CustomInput = /** @class */ (function (_super) {
    __extends(CustomInput, _super);
    function CustomInput() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            value: null,
            error: false
        };
        _this.click = function () {
            // this.inputRef?.click()
        };
        _this.focus = function () {
            // this.inputRef?.focus()
        };
        _this.blur = function () {
            // this.inputRef?.blur()
        };
        return _this;
    }
    CustomInput.prototype.setValue = function (value) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (!(typeof ((_a = this.elementRef) === null || _a === void 0 ? void 0 : _a.setValue) === "function")) return [3 /*break*/, 2];
                        return [4 /*yield*/, ((_b = this.elementRef) === null || _b === void 0 ? void 0 : _b.setValue(value))];
                    case 1: return [2 /*return*/, _c.sent()];
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    CustomInput.prototype.getValue = function (validation) {
        var _a, _b;
        if (typeof ((_a = this.elementRef) === null || _a === void 0 ? void 0 : _a.getValue) === "function") {
            return (_b = this.elementRef) === null || _b === void 0 ? void 0 : _b.getValue(validation);
        }
        return null;
    };
    CustomInput.prototype.clear = function () {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (!(typeof ((_a = this.elementRef) === null || _a === void 0 ? void 0 : _a.clear) === "function")) return [3 /*break*/, 2];
                        return [4 /*yield*/, ((_b = this.elementRef) === null || _b === void 0 ? void 0 : _b.clear())];
                    case 1: return [2 /*return*/, _c.sent()];
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    CustomInput.prototype.validation = function () {
        var _a, _b;
        if (typeof ((_a = this.elementRef) === null || _a === void 0 ? void 0 : _a.validation) === "function") {
            return (_b = this.elementRef) === null || _b === void 0 ? void 0 : _b.validation();
        }
        return true;
    };
    CustomInput.prototype.render = function () {
        var _this = this;
        var _a = this.props, element = _a.element, rest = __rest(_a, ["element"]);
        var render = React__default["default"].createElement(element, __assign({ ref: function (el) { return _this.elementRef = el; } }, rest));
        return (React__default["default"].createElement(React.Fragment, null,
            " ",
            render,
            " "));
    };
    return CustomInput;
}(React.Component));

var DateInput = /** @class */ (function (_super) {
    __extends(DateInput, _super);
    function DateInput() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            value: _this.props.defaultValue || null,
            error: false
        };
        _this.onChange = function (event) {
            var value = event && event.toDate ? event.toDate() : event;
            _this.setValue(value || null);
        };
        _this.onClick = function (event) {
            clearTimeout(_this.validationTimeout);
            _this.setState(__assign(__assign({}, _this.state), { error: false }));
        };
        _this.click = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.click();
        };
        _this.focus = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.focus();
        };
        _this.blur = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.blur();
        };
        return _this;
    }
    DateInput.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        switch (true) {
            case this.state.value !== nextState.value:
            case this.state.error !== nextState.error:
            case this.props.label !== nextProps.label:
                return true;
            default: return false;
        }
    };
    DateInput.prototype.setValue = function (value) {
        return __awaiter(this, void 0, void 0, function () {
            var setStatePromise;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (value === this.state.value)
                            return [2 /*return*/, Promise.resolve()];
                        return [4 /*yield*/, this.setState(__assign(__assign({}, this.state), { value: value }))];
                    case 1:
                        setStatePromise = _a.sent();
                        if (!(typeof this.props._call_parent_for_update === "function")) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.props._call_parent_for_update()];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        if (!(typeof this.props.onChangeValue === "function")) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.props.onChangeValue(value)];
                    case 4:
                        _a.sent();
                        _a.label = 5;
                    case 5: return [2 /*return*/, setStatePromise];
                }
            });
        });
    };
    DateInput.prototype.getValue = function () {
        return this.state.value || null;
    };
    DateInput.prototype.clear = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.setValue(this.props.defaultValue || null)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    DateInput.prototype.validation = function () {
        var _this = this;
        if (!this.state.value && this.props.required) {
            clearTimeout(this.validationTimeout);
            this.setState(__assign(__assign({}, this.state), { error: true }));
            this.validationTimeout = setTimeout(function () {
                _this.setState(__assign(__assign({}, _this.state), { error: false }));
            }, 3000);
            return false;
        }
        return true;
    };
    DateInput.prototype.render = function () {
        var _this = this;
        var _a = this.props; _a.onChangeValue; _a.defaultValue; var dateAdapter = _a.dateAdapter, variant = _a.variant, required = _a.required; _a.visible; _a._call_parent_for_update; var restProps = __rest(_a, ["onChangeValue", "defaultValue", "dateAdapter", "variant", "required", "visible", "_call_parent_for_update"]);
        return (React__default["default"].createElement(xDatePickers.LocalizationProvider, { dateAdapter: dateAdapter || AdapterDayjs.AdapterDayjs },
            React__default["default"].createElement(xDatePickers.DatePicker, __assign({}, restProps, { value: this.state.value, onChange: this.onChange, inputRef: function (el) { return _this.inputRef = el; }, renderInput: function (params) { return (React__default["default"].createElement(TextField__default["default"], __assign({}, params, { inputProps: __assign(__assign({}, params.inputProps), _this.props.inputProps), fullWidth: _this.props.fullWidth || false, variant: variant || 'standard', required: required || false, error: _this.state.error, onClick: _this.onClick }))); } }))));
    };
    return DateInput;
}(React.Component));

var DatetimeInput = /** @class */ (function (_super) {
    __extends(DatetimeInput, _super);
    function DatetimeInput() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            value: _this.props.defaultValue || null,
            error: false
        };
        _this.onChange = function (event) {
            var value = event && event.toDate ? event.toDate() : event;
            _this.setValue(value || null);
        };
        _this.onClick = function (event) {
            clearTimeout(_this.validationTimeout);
            _this.setState(__assign(__assign({}, _this.state), { error: false }));
        };
        _this.click = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.click();
        };
        _this.focus = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.focus();
        };
        _this.blur = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.blur();
        };
        return _this;
    }
    DatetimeInput.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        switch (true) {
            case this.state.value !== nextState.value:
            case this.state.error !== nextState.error:
            case this.props.label !== nextProps.label:
                return true;
            default: return false;
        }
    };
    DatetimeInput.prototype.setValue = function (value) {
        return __awaiter(this, void 0, void 0, function () {
            var setStatePromise;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (value === this.state.value)
                            return [2 /*return*/, Promise.resolve()];
                        return [4 /*yield*/, this.setState(__assign(__assign({}, this.state), { value: value }))];
                    case 1:
                        setStatePromise = _a.sent();
                        if (!(typeof this.props._call_parent_for_update === "function")) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.props._call_parent_for_update()];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        if (typeof this.props.onChangeValue === "function") {
                            this.props.onChangeValue(value);
                        }
                        return [2 /*return*/, setStatePromise];
                }
            });
        });
    };
    DatetimeInput.prototype.getValue = function () {
        return this.state.value || null;
    };
    DatetimeInput.prototype.clear = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.setValue(this.props.defaultValue || null)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    DatetimeInput.prototype.validation = function () {
        var _this = this;
        if (!this.state.value && this.props.required) {
            clearTimeout(this.validationTimeout);
            this.setState(__assign(__assign({}, this.state), { error: true }));
            this.validationTimeout = setTimeout(function () {
                _this.setState(__assign(__assign({}, _this.state), { error: false }));
            }, 3000);
            return false;
        }
        return true;
    };
    DatetimeInput.prototype.render = function () {
        var _this = this;
        var _a = this.props; _a.onChangeValue; _a.defaultValue; var dateAdapter = _a.dateAdapter, variant = _a.variant, required = _a.required; _a.visible; _a._call_parent_for_update; var restProps = __rest(_a, ["onChangeValue", "defaultValue", "dateAdapter", "variant", "required", "visible", "_call_parent_for_update"]);
        return (React__default["default"].createElement(xDatePickers.LocalizationProvider, { dateAdapter: dateAdapter || AdapterDayjs.AdapterDayjs },
            React__default["default"].createElement(xDatePickers.DateTimePicker, __assign({}, restProps, { ampm: this.props.ampm || false, value: this.state.value, onChange: this.onChange, inputRef: function (el) { return _this.inputRef = el; }, renderInput: function (params) { return (React__default["default"].createElement(TextField__default["default"], __assign({}, params, { inputProps: __assign(__assign({}, params.inputProps), _this.props.inputProps), fullWidth: _this.props.fullWidth || false, variant: variant || 'standard', required: required || false, error: _this.state.error, onClick: _this.onClick }))); } }))));
    };
    return DatetimeInput;
}(React.Component));

var FileInput = /** @class */ (function (_super) {
    __extends(FileInput, _super);
    function FileInput(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            value: _this.props.defaultValue || null,
            error: false,
            inputKey: randomString(20)
        };
        _this.inputIdentity = '';
        _this.textHelperIdentity = '';
        _this.onChange = function (event) {
            var value = event.target.files;
            _this.setValue(value || null);
        };
        _this.onClick = function (event) {
            clearTimeout(_this.validationTimeout);
            _this.setState(__assign(__assign({}, _this.state), { error: false }));
        };
        _this.click = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.click();
        };
        _this.focus = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.focus();
        };
        _this.blur = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.blur();
        };
        _this.inputIdentity = randomString(20);
        _this.textHelperIdentity = randomString(20);
        return _this;
    }
    FileInput.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        switch (true) {
            case this.state.value !== nextState.value:
            case this.state.error !== nextState.error:
            case this.props.label !== nextProps.label:
                return true;
            default: return false;
        }
    };
    FileInput.prototype.setValue = function (value) {
        return __awaiter(this, void 0, void 0, function () {
            var inputKey, setStatePromise;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (value === this.state.value)
                            return [2 /*return*/, Promise.resolve()];
                        inputKey = !value ? randomString(20) : this.state.inputKey;
                        return [4 /*yield*/, this.setState(__assign(__assign({}, this.state), { value: value, inputKey: inputKey }))];
                    case 1:
                        setStatePromise = _a.sent();
                        if (this.inputRef && value) {
                            this.inputRef.files = value;
                        }
                        if (!(typeof this.props._call_parent_for_update === "function")) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.props._call_parent_for_update()];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        if (!(typeof this.props.onChangeValue === "function")) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.props.onChangeValue(value)];
                    case 4:
                        _a.sent();
                        _a.label = 5;
                    case 5: return [2 /*return*/, setStatePromise];
                }
            });
        });
    };
    FileInput.prototype.getValue = function () {
        return this.state.value || null;
    };
    FileInput.prototype.clear = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.setValue(this.props.defaultValue || null)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    FileInput.prototype.validation = function () {
        var _this = this;
        if (!this.state.value && this.props.required) {
            clearTimeout(this.validationTimeout);
            this.setState(__assign(__assign({}, this.state), { error: true }));
            this.validationTimeout = setTimeout(function () {
                _this.setState(__assign(__assign({}, _this.state), { error: false }));
            }, 3000);
            return false;
        }
        return true;
    };
    FileInput.prototype.render = function () {
        var _this = this;
        var _a, _b;
        var _c = this.props; _c.defaultValue; _c.onChangeValue; _c.label; var helperText = _c.helperText, FormControlProps = _c.FormControlProps, InputLabelProps = _c.InputLabelProps, FormHelperTextProps = _c.FormHelperTextProps, InputProps = _c.InputProps, multiple = _c.multiple; _c.visible; _c._call_parent_for_update; var restProps = __rest(_c, ["defaultValue", "onChangeValue", "label", "helperText", "FormControlProps", "InputLabelProps", "FormHelperTextProps", "InputProps", "multiple", "visible", "_call_parent_for_update"]);
        return (React__default["default"].createElement(material.FormControl, __assign({}, FormControlProps, { variant: (_a = FormControlProps === null || FormControlProps === void 0 ? void 0 : FormControlProps.variant) !== null && _a !== void 0 ? _a : 'standard' }),
            this.props.label ? (React__default["default"].createElement(material.InputLabel, __assign({}, InputLabelProps, { shrink: (_b = InputLabelProps === null || InputLabelProps === void 0 ? void 0 : InputLabelProps.shrink) !== null && _b !== void 0 ? _b : true, htmlFor: this.inputIdentity }), this.props.label)) : null,
            React__default["default"].createElement(material.Input, __assign({}, restProps, { id: this.inputIdentity, "aria-describedby": this.textHelperIdentity, type: "file", inputProps: __assign(__assign({ multiple: multiple || false }, InputProps), { key: this.state.inputKey }), error: this.state.error, onChange: this.onChange, onClick: this.onClick, 
                // value={this.state.value?.length ? this.state.value[0].name : ''}
                inputRef: function (el) { return _this.inputRef = el; } })),
            helperText ? (React__default["default"].createElement(material.FormHelperText, __assign({}, FormHelperTextProps, { id: this.textHelperIdentity }), helperText)) : null));
    };
    return FileInput;
}(React.Component));

var ItemsInput = /** @class */ (function (_super) {
    __extends(ItemsInput, _super);
    function ItemsInput() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            error: false,
            items: []
        };
        _this.formBuilderRef = {};
        _this.sleep = function (ms) {
            return new Promise(function (resolve) { return setTimeout(resolve, ms); });
        };
        _this.setItemValue = function (key, object) { return __awaiter(_this, void 0, void 0, function () {
            var formBuilderRef;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        formBuilderRef = this.formBuilderRef[key];
                        if (!!formBuilderRef) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.sleep(5)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.setItemValue(key, object)];
                    case 2: return [2 /*return*/, _a.sent()];
                    case 3: return [2 /*return*/, formBuilderRef.setValues(object)];
                }
            });
        }); };
        _this.exportFormBuilderData = function () {
            var values = [];
            for (var key in _this.formBuilderRef) {
                var builder = _this.formBuilderRef[key];
                if (builder) {
                    values.push(builder.getValues());
                }
            }
            return values;
        };
        _this.addItem = function () { return __awaiter(_this, void 0, void 0, function () {
            var random;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        random = randomString(8);
                        return [4 /*yield*/, this.setState(function (oldState) {
                                var state = __assign({}, oldState);
                                state.items = __spreadArray(__spreadArray([], state.items, true), [random], false);
                                return state;
                            })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, random];
                }
            });
        }); };
        _this.copyItem = function (key) { return function () { return __awaiter(_this, void 0, void 0, function () {
            var newKey, builder, copyData;
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.addItem()];
                    case 1:
                        newKey = _b.sent();
                        builder = this.formBuilderRef[key];
                        if (builder) {
                            copyData = builder.getValues(false).data;
                            (_a = this.formBuilderRef[newKey]) === null || _a === void 0 ? void 0 : _a.setValues(copyData);
                        }
                        return [2 /*return*/];
                }
            });
        }); }; };
        _this.removeItem = function (key) { return function () { return __awaiter(_this, void 0, void 0, function () {
            var formBuilderRef;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        formBuilderRef = this.formBuilderRef[key];
                        if (!formBuilderRef) return [3 /*break*/, 2];
                        formBuilderRef.clear();
                        return [4 /*yield*/, this.setState(function (oldState) {
                                var state = __assign({}, oldState);
                                state.items = state.items.filter(function (item) { return item !== key; });
                                return state;
                            })];
                    case 1:
                        _a.sent();
                        delete this.formBuilderRef[key];
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        }); }; };
        _this.removeAll = function () {
            return _this.setValue(null);
        };
        _this.click = function () { };
        _this.focus = function () { };
        _this.blur = function () { };
        _this.renderItem = function (key) {
            return (React__default["default"].createElement(material.Box, { key: key, display: "flex", alignItems: "center" },
                _this.props.removeIcon !== false ? (React__default["default"].createElement(material.IconButton, { onClick: _this.removeItem(key) }, _this.props.removeIcon ? _this.props.removeIcon : React__default["default"].createElement(iconsMaterial.Remove, null))) : null,
                React__default["default"].createElement(FormBuilder, { inputs: _this.props.inputs, ref: function (el) {
                        var _a;
                        return _this.formBuilderRef = __assign(__assign({}, _this.formBuilderRef), (_a = {}, _a[key] = el, _a));
                    } }),
                _this.props.copyIcon !== false ? (React__default["default"].createElement(material.IconButton, { onClick: _this.copyItem(key) }, _this.props.copyIcon ? _this.props.copyIcon : React__default["default"].createElement(iconsMaterial.CopyAll, null))) : null));
        };
        return _this;
    }
    ItemsInput.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        switch (true) {
            case JSON.stringify(this.state.items) !== JSON.stringify(nextState.items):
                return true;
            default: return false;
        }
    };
    ItemsInput.prototype.setValue = function (values) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.formBuilderRef = {};
                        return [4 /*yield*/, this.setState(__assign(__assign({}, this.state), { items: [] }))];
                    case 1:
                        _a.sent();
                        if (!values)
                            return [2 /*return*/, Promise.resolve()];
                        return [4 /*yield*/, Promise.all(values.map(function (object) { return __awaiter(_this, void 0, void 0, function () {
                                var key;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, this.addItem()];
                                        case 1:
                                            key = _a.sent();
                                            return [2 /*return*/, this.setItemValue(key, object)];
                                    }
                                });
                            }); }))];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    ItemsInput.prototype.getValue = function () {
        var items = this.exportFormBuilderData();
        return items.map(function (item) { return item.data; });
    };
    ItemsInput.prototype.clear = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.removeAll()];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    ItemsInput.prototype.validation = function () {
        var data = this.exportFormBuilderData();
        return !data.some(function (datum) { return !(datum === null || datum === void 0 ? void 0 : datum.validation.status); });
    };
    ItemsInput.prototype.render = function () {
        var _this = this;
        return (React__default["default"].createElement(material.Box, null,
            this.props.renderHeader ? (this.props.renderHeader(this.addItem, this.removeAll)) : (React__default["default"].createElement(material.Box, null,
                React__default["default"].createElement(material.IconButton, { onClick: this.addItem },
                    React__default["default"].createElement(iconsMaterial.Add, null)),
                React__default["default"].createElement(material.IconButton, { onClick: this.removeAll },
                    React__default["default"].createElement(iconsMaterial.Delete, null)))),
            this.state.items.map(function (key) {
                return _this.props.itemWrapper
                    ? _this.props.itemWrapper(_this.renderItem(key))
                    : _this.renderItem(key);
            })));
    };
    return ItemsInput;
}(React.Component));

var MaskInput = /** @class */ (function (_super) {
    __extends(MaskInput, _super);
    function MaskInput() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            value: _this.props.defaultValue || null,
            error: false
        };
        _this.onChange = function (event) {
            var value = event.target.value;
            if (_this.props.formatter && typeof _this.props.formatter === "function") {
                var formattedValue = _this.props.formatter(value);
                if (formattedValue !== undefined) {
                    value = formattedValue;
                }
            }
            _this.normalizeValue(value);
        };
        _this.normalizeValue = function (value) { return __awaiter(_this, void 0, void 0, function () {
            var pattern, pureValue, maskedValues, valueForLength;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!value)
                            return [2 /*return*/, this.setValue(null)];
                        pattern = this.props.pattern;
                        pureValue = value.replace(/[^0-9]/g, '');
                        maskedValues = mask(pureValue, pattern, this.props.char || '_');
                        return [4 /*yield*/, this.setValue(pureValue ? maskedValues : null)];
                    case 1:
                        _a.sent();
                        valueForLength = maskedValues.match(/.*[0-9]/);
                        if (this.inputRef && valueForLength) {
                            this.inputRef.selectionStart = this.inputRef.selectionEnd = valueForLength[0].length;
                        }
                        return [2 /*return*/];
                }
            });
        }); };
        _this.onClick = function () {
            clearTimeout(_this.validationTimeout);
            _this.setState(__assign(__assign({}, _this.state), { error: false }));
        };
        _this.click = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.click();
        };
        _this.focus = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.focus();
        };
        _this.blur = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.blur();
        };
        return _this;
    }
    MaskInput.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        switch (true) {
            case this.state.value !== nextState.value:
            case this.state.error !== nextState.error:
            case this.props.label !== nextProps.label:
            case this.props.pattern !== nextProps.pattern:
            case this.props.char !== nextProps.char:
                return true;
            default: return false;
        }
    };
    MaskInput.prototype.setValue = function (value) {
        return __awaiter(this, void 0, void 0, function () {
            var setStatePromise;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (value === this.state.value)
                            return [2 /*return*/, Promise.resolve()];
                        return [4 /*yield*/, this.setState(__assign(__assign({}, this.state), { value: value }))];
                    case 1:
                        setStatePromise = _a.sent();
                        if (!(typeof this.props._call_parent_for_update === "function")) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.props._call_parent_for_update()];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        if (!(typeof this.props.onChangeValue === "function")) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.props.onChangeValue(value)];
                    case 4:
                        _a.sent();
                        _a.label = 5;
                    case 5: return [2 /*return*/, setStatePromise];
                }
            });
        });
    };
    MaskInput.prototype.getValue = function () {
        return this.state.value || null;
    };
    MaskInput.prototype.clear = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.setValue(this.props.defaultValue || null)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    MaskInput.prototype.validation = function () {
        var _this = this;
        if (!this.state.value && this.props.required) {
            clearTimeout(this.validationTimeout);
            this.setState(__assign(__assign({}, this.state), { error: true }));
            this.validationTimeout = setTimeout(function () {
                _this.setState(__assign(__assign({}, _this.state), { error: false }));
            }, 3000);
            return false;
        }
        return true;
    };
    MaskInput.prototype.render = function () {
        var _this = this;
        var _a = this.props; _a.onChangeValue; _a.formatter; _a.visible; _a._call_parent_for_update; _a.defaultValue; var restProps = __rest(_a, ["onChangeValue", "formatter", "visible", "_call_parent_for_update", "defaultValue"]);
        return React__default["default"].createElement(TextField__default["default"], __assign({}, restProps, { variant: this.props.variant || "standard", error: this.state.error, onChange: this.onChange, onClick: this.onClick, value: this.state.value || '', inputRef: function (el) { return _this.inputRef = el; } }));
    };
    return MaskInput;
}(React.Component));

var img$2 = "data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' id='flag-icons-ae' viewBox='0 0 640 480'%3e %3cpath fill='%2300732f' d='M0 0h640v160H0z'/%3e %3cpath fill='white' d='M0 160h640v160H0z'/%3e %3cpath d='M0 320h640v160H0z'/%3e %3cpath fill='red' d='M0 0h220v480H0z'/%3e%3c/svg%3e";

var img$1 = "data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' id='flag-icons-ir' viewBox='0 0 640 480'%3e %3cdefs%3e %3cclipPath id='a'%3e %3cpath fill-opacity='.7' d='M-85.3 0h682.7v512H-85.3z'/%3e %3c/clipPath%3e %3c/defs%3e %3cg fill-rule='evenodd' clip-path='url(%23a)' transform='translate(80) scale(.9375)'%3e %3cpath fill='white' d='M-192 0h896v512h-896z'/%3e %3cpath fill='%23da0000' d='M-192 343.8h896V512h-896z'/%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M-21.6 351h49v3.3h-49zm7.3 16.8h3.4v3.3h-3.4zm41.9 0v3.3h-9.8v-3.4zm5.2-16.8h3.4v20h-3.4z'/%3e %3cpath d='M52.4 367.7v3.4H33.8v-3.4zm-34.6-7.9H21v11.3h-3.3z'/%3e %3cpath d='M49.6 351H53v20h-3.4zm-8.4 0h3.3v20h-3.3zm-44.8 8v3.4h-18V359zm39.3 0v3.4h-18V359z'/%3e %3cpath d='M17.8 359.9H21V371h-3.3z'/%3e %3cpath d='M17.8 359.9H21V371h-3.3z'/%3e %3cpath d='M17.8 359.9H21V371h-3.3zm-39.3 0h3.3V371h-3.3zm28.8 0h3.4V371H7.3zm-14.3 0h3.4V371H-7z'/%3e %3cpath d='M9.6 367.7v3.4H-5.5v-3.4zm1-8.7v3.4H1V359z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M-102.2 351h49v3.3h-49zm7.3 16.8h3.4v3.3H-95zm41.9 0v3.3h-9.8v-3.4zm5.2-16.8h3.4v20h-3.4z'/%3e %3cpath d='M-28.2 367.7v3.4h-18.6v-3.4zm-34.6-7.9h3.3v11.3h-3.3z'/%3e %3cpath d='M-31 351h3.4v20H-31zm-8.4 0h3.3v20h-3.3zm-44.8 8v3.4h-18V359zm39.3 0v3.4h-18V359z'/%3e %3cpath d='M-62.8 359.9h3.3V371h-3.3z'/%3e %3cpath d='M-62.8 359.9h3.3V371h-3.3z'/%3e %3cpath d='M-62.8 359.9h3.3V371h-3.3zm-39.3 0h3.3V371h-3.3zm28.8 0h3.3V371h-3.3zm-14.3 0h3.4V371h-3.4z'/%3e %3cpath d='M-71 367.7v3.4h-15v-3.4zm1-8.7v3.4h-9.6V359z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M58.3 351h49v3.3h-49zm7.3 16.8H69v3.3h-3.4zm41.9 0v3.3h-9.8v-3.4zm5.3-16.8h3.4v20h-3.4z'/%3e %3cpath d='M132.3 367.7v3.4h-18.6v-3.4zm-34.6-7.9h3.4v11.3h-3.4z'/%3e %3cpath d='M129.5 351h3.4v20h-3.4zm-8.4 0h3.4v20H121zm-44.8 8v3.4h-18V359zm39.3 0v3.4h-18V359z'/%3e %3cpath d='M97.7 359.9h3.4V371h-3.4z'/%3e %3cpath d='M97.7 359.9h3.4V371h-3.4z'/%3e %3cpath d='M97.7 359.9h3.4V371h-3.4zm-39.3 0h3.4V371h-3.4zm28.8 0h3.4V371h-3.4zm-14.3 0h3.4V371h-3.4z'/%3e %3cpath d='M89.6 367.7v3.4H74.4v-3.4zm1-8.7v3.4H81V359z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M622.7 351h49v3.3h-49zm7.3 16.8h3.4v3.3H630zm41.9 0v3.3H662v-3.4zm5.3-16.8h3.3v20h-3.4z'/%3e %3cpath d='M696.7 367.7v3.4H678v-3.4zm-34.6-7.9h3.4v11.3H662z'/%3e %3cpath d='M694 351h3.3v20h-3.4zm-8.5 0h3.4v20h-3.4zm-44.8 8v3.4h-18V359zm39.3 0v3.4h-18V359z'/%3e %3cpath d='M662 359.9h3.5V371H662z'/%3e %3cpath d='M662 359.9h3.5V371H662z'/%3e %3cpath d='M662 359.9h3.5V371H662zm-39.2 0h3.4V371h-3.4zm28.8 0h3.4V371h-3.4zm-14.3 0h3.4V371h-3.4z'/%3e %3cpath d='M654 367.7v3.4h-15.2v-3.4zm1-8.7v3.4h-9.6V359z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M138.7 351h49.1v3.3h-49zm7.4 16.8h3.3v3.3h-3.3zm41.8 0v3.3h-9.8v-3.4zm5.3-16.8h3.4v20h-3.4z'/%3e %3cpath d='M212.8 367.7v3.4h-18.6v-3.4zm-34.7-7.9h3.4v11.3h-3.4z'/%3e %3cpath d='M210 351h3.4v20H210zm-8.5 0h3.4v20h-3.4zm-44.8 8v3.4h-17.9V359zm39.3 0v3.4h-17.9V359z'/%3e %3cpath d='M178.1 359.9h3.4V371h-3.4z'/%3e %3cpath d='M178.1 359.9h3.4V371h-3.4z'/%3e %3cpath d='M178.1 359.9h3.4V371h-3.4zm-39.3 0h3.4V371h-3.4zm28.8 0h3.4V371h-3.4zm-14.2 0h3.3V371h-3.3z'/%3e %3cpath d='M170 367.7v3.4h-15.1v-3.4zm1-8.7v3.4h-9.6V359z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M219.5 351h49v3.3h-49zm7.3 16.8h3.4v3.3h-3.4zm41.9 0v3.3h-9.8v-3.4zM274 351h3.3v20H274z'/%3e %3cpath d='M293.5 367.7v3.4h-18.6v-3.4zm-34.6-7.9h3.4v11.3h-3.4z'/%3e %3cpath d='M290.7 351h3.4v20h-3.4zm-8.4 0h3.4v20h-3.4zm-44.8 8v3.4h-18V359zm39.3 0v3.4h-18V359z'/%3e %3cpath d='M258.9 359.9h3.4V371h-3.4z'/%3e %3cpath d='M258.9 359.9h3.4V371h-3.4z'/%3e %3cpath d='M258.9 359.9h3.4V371h-3.4zm-39.3 0h3.3V371h-3.3zm28.8 0h3.4V371h-3.4zm-14.3 0h3.4V371H234z'/%3e %3cpath d='M250.8 367.7v3.4h-15.2v-3.4zm1-8.7v3.4H242V359z'/%3e %3c/g%3e %3cpath fill='%23239f40' d='M-192 0h896v168.2h-896z'/%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M300.7 351h49v3.3h-49zm7.3 16.8h3.4v3.3H308zm41.9 0v3.3H340v-3.4zm5.3-16.8h3.3v20h-3.3z'/%3e %3cpath d='M374.7 367.7v3.4h-18.6v-3.4zm-34.6-7.9h3.4v11.3H340z'/%3e %3cpath d='M372 351h3.3v20H372zm-8.5 0h3.4v20h-3.4zm-44.8 8v3.4h-18V359zm39.3 0v3.4h-18V359z'/%3e %3cpath d='M340 359.9h3.5V371H340z'/%3e %3cpath d='M340 359.9h3.5V371H340z'/%3e %3cpath d='M340 359.9h3.5V371H340zm-39.2 0h3.4V371h-3.4zm28.8 0h3.4V371h-3.4zm-14.3 0h3.4V371h-3.4z'/%3e %3cpath d='M332 367.7v3.4h-15.2v-3.4zm1-8.7v3.4h-9.6V359z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M381.4 351h49v3.3h-49zm7.3 16.8h3.4v3.3h-3.4zm42 0v3.3h-9.9v-3.4zm5.2-16.8h3.4v20h-3.4z'/%3e %3cpath d='M455.4 367.7v3.4h-18.6v-3.4zm-34.6-7.9h3.4v11.3h-3.4z'/%3e %3cpath d='M452.7 351h3.3v20h-3.3zm-8.5 0h3.4v20h-3.4zm-44.8 8v3.4h-17.9V359zm39.3 0v3.4h-17.9V359z'/%3e %3cpath d='M420.8 359.9h3.4V371h-3.4z'/%3e %3cpath d='M420.8 359.9h3.4V371h-3.4z'/%3e %3cpath d='M420.8 359.9h3.4V371h-3.4zm-39.3 0h3.4V371h-3.4zm28.8 0h3.4V371h-3.4zm-14.3 0h3.4V371h-3.3z'/%3e %3cpath d='M412.7 367.7v3.4h-15.1v-3.4zm1-8.7v3.4H404V359z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M462.2 351h49v3.3h-49zm7.3 16.8h3.4v3.3h-3.4zm41.9 0v3.3h-9.8v-3.4zm5.2-16.8h3.4v20h-3.4z'/%3e %3cpath d='M536.2 367.7v3.4h-18.6v-3.4zm-34.7-7.9h3.4v11.3h-3.4z'/%3e %3cpath d='M533.4 351h3.4v20h-3.4zm-8.4 0h3.3v20H525zm-44.8 8v3.4h-18V359zm39.3 0v3.4h-18V359z'/%3e %3cpath d='M501.6 359.9h3.3V371h-3.3z'/%3e %3cpath d='M501.6 359.9h3.3V371h-3.3z'/%3e %3cpath d='M501.6 359.9h3.3V371h-3.3zm-39.4 0h3.4V371h-3.4zm28.9 0h3.3V371h-3.3zm-14.3 0h3.4V371h-3.4z'/%3e %3cpath d='M493.4 367.7v3.4h-15.1v-3.4zm1-8.7v3.4h-9.6V359z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M543.4 351h49v3.3h-49zm7.3 16.8h3.4v3.3h-3.4zm41.9 0v3.3h-9.8v-3.4zm5.2-16.8h3.4v20h-3.4z'/%3e %3cpath d='M617.4 367.7v3.4h-18.6v-3.4zm-34.6-7.9h3.3v11.3h-3.3z'/%3e %3cpath d='M614.6 351h3.4v20h-3.4zm-8.4 0h3.3v20h-3.3zm-44.8 8v3.4h-18V359zm39.3 0v3.4h-18V359z'/%3e %3cpath d='M582.8 359.9h3.3V371h-3.3z'/%3e %3cpath d='M582.8 359.9h3.3V371h-3.3z'/%3e %3cpath d='M582.8 359.9h3.3V371h-3.3zm-39.3 0h3.3V371h-3.3zm28.8 0h3.4V371h-3.4zm-14.3 0h3.4V371H558z'/%3e %3cpath d='M574.6 367.7v3.4h-15.1v-3.4zm1-8.7v3.4H566V359z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M-183.8 351h49v3.3h-49zm7.3 16.8h3.4v3.3h-3.4zm42 0v3.3h-9.9v-3.4zm5.2-16.8h3.4v20h-3.4z'/%3e %3cpath d='M-109.8 367.7v3.4h-18.6v-3.4zm-34.6-7.9h3.4v11.3h-3.4z'/%3e %3cpath d='M-112.5 351h3.3v20h-3.3zm-8.5 0h3.4v20h-3.4zm-44.8 8v3.4h-17.9V359zm39.3 0v3.4h-17.9V359z'/%3e %3cpath d='M-144.4 359.9h3.4V371h-3.4z'/%3e %3cpath d='M-144.4 359.9h3.4V371h-3.4z'/%3e %3cpath d='M-144.4 359.9h3.4V371h-3.4zm-39.3 0h3.4V371h-3.4zm28.8 0h3.4V371h-3.4zm-14.3 0h3.4V371h-3.4z'/%3e %3cpath d='M-152.5 367.7v3.4h-15.2v-3.4zm1-8.7v3.4h-9.6V359z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M-21.6 143.4h49v3.4h-49zm7.3 17h3.4v3.2h-3.4zm41.9-.2v3.4h-9.8v-3.4zm5.2-16.8h3.4v20.2h-3.4z'/%3e %3cpath d='M52.4 160.2v3.4H33.8v-3.4zm-34.6-7.9H21v11.3h-3.3z'/%3e %3cpath d='M49.6 143.4H53v20.2h-3.4zm-8.4 0h3.3v20.2h-3.3zm-44.8 8v3.4h-18v-3.3zm39.3 0v3.4h-18v-3.3z'/%3e %3cpath d='M17.8 152.3H21v11.3h-3.3z'/%3e %3cpath d='M17.8 152.3H21v11.3h-3.3z'/%3e %3cpath d='M17.8 152.3H21v11.3h-3.3zm-39.3 0h3.3v11.3h-3.3zm28.8 0h3.4v11.3H7.3zm-14.3 0h3.4v11.3H-7z'/%3e %3cpath d='M9.6 160.2v3.4H-5.5v-3.4zm1-8.7v3.3H1v-3.3z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M-102.2 143.4h49v3.4h-49zm7.3 17h3.4v3.2H-95zm41.9-.2v3.4h-9.8v-3.4zm5.2-16.8h3.4v20.2h-3.4z'/%3e %3cpath d='M-28.2 160.2v3.4h-18.6v-3.4zm-34.6-7.9h3.3v11.3h-3.3z'/%3e %3cpath d='M-31 143.4h3.4v20.2H-31zm-8.4 0h3.3v20.2h-3.3zm-44.8 8v3.4h-18v-3.3zm39.3 0v3.4h-18v-3.3z'/%3e %3cpath d='M-62.8 152.3h3.3v11.3h-3.3z'/%3e %3cpath d='M-62.8 152.3h3.3v11.3h-3.3z'/%3e %3cpath d='M-62.8 152.3h3.3v11.3h-3.3zm-39.3 0h3.3v11.3h-3.3zm28.8 0h3.3v11.3h-3.3zm-14.3 0h3.4v11.3h-3.4z'/%3e %3cpath d='M-71 160.2v3.4h-15v-3.4zm1-8.7v3.3h-9.6v-3.3z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M58.3 143.4h49v3.4h-49zm7.3 17H69v3.2h-3.4zm41.9-.2v3.4h-9.8v-3.4zm5.3-16.8h3.4v20.2h-3.4z'/%3e %3cpath d='M132.3 160.2v3.4h-18.6v-3.4zm-34.6-7.9h3.4v11.3h-3.4z'/%3e %3cpath d='M129.5 143.4h3.4v20.2h-3.4zm-8.4 0h3.4v20.2H121zm-44.8 8v3.4h-18v-3.3zm39.3 0v3.4h-18v-3.3z'/%3e %3cpath d='M97.7 152.3h3.4v11.3h-3.4z'/%3e %3cpath d='M97.7 152.3h3.4v11.3h-3.4z'/%3e %3cpath d='M97.7 152.3h3.4v11.3h-3.4zm-39.3 0h3.4v11.3h-3.4zm28.8 0h3.4v11.3h-3.4zm-14.3 0h3.4v11.3h-3.4z'/%3e %3cpath d='M89.6 160.2v3.4H74.4v-3.4zm1-8.7v3.3H81v-3.3z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M622.7 143.4h49v3.4h-49zm7.3 17h3.4v3.2H630zm41.9-.2v3.4H662v-3.4zm5.3-16.8h3.3v20.2h-3.4z'/%3e %3cpath d='M696.7 160.2v3.4H678v-3.4zm-34.6-7.9h3.4v11.3H662z'/%3e %3cpath d='M694 143.4h3.3v20.2h-3.4zm-8.5 0h3.4v20.2h-3.4zm-44.8 8v3.4h-18v-3.3zm39.3 0v3.4h-18v-3.3z'/%3e %3cpath d='M662 152.3h3.5v11.3H662z'/%3e %3cpath d='M662 152.3h3.5v11.3H662z'/%3e %3cpath d='M662 152.3h3.5v11.3H662zm-39.2 0h3.4v11.3h-3.4zm28.8 0h3.4v11.3h-3.4zm-14.3 0h3.4v11.3h-3.4z'/%3e %3cpath d='M654 160.2v3.4h-15.2v-3.4zm1-8.7v3.3h-9.6v-3.3z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M138.7 143.4h49.1v3.4h-49zm7.4 17h3.3v3.2h-3.3zm41.8-.2v3.4h-9.8v-3.4zm5.3-16.8h3.4v20.2h-3.4z'/%3e %3cpath d='M212.8 160.2v3.4h-18.6v-3.4zm-34.7-7.9h3.4v11.3h-3.4z'/%3e %3cpath d='M210 143.4h3.4v20.2H210zm-8.5 0h3.4v20.2h-3.4zm-44.8 8v3.4h-17.9v-3.3zm39.3 0v3.4h-17.9v-3.3z'/%3e %3cpath d='M178.1 152.3h3.4v11.3h-3.4z'/%3e %3cpath d='M178.1 152.3h3.4v11.3h-3.4z'/%3e %3cpath d='M178.1 152.3h3.4v11.3h-3.4zm-39.3 0h3.4v11.3h-3.4zm28.8 0h3.4v11.3h-3.4zm-14.2 0h3.3v11.3h-3.3z'/%3e %3cpath d='M170 160.2v3.4h-15.1v-3.4zm1-8.7v3.3h-9.6v-3.3z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M219.5 143.4h49v3.4h-49zm7.3 17h3.4v3.2h-3.4zm41.9-.2v3.4h-9.8v-3.4zm5.3-16.8h3.3v20.2H274z'/%3e %3cpath d='M293.5 160.2v3.4h-18.6v-3.4zm-34.6-7.9h3.4v11.3h-3.4z'/%3e %3cpath d='M290.7 143.4h3.4v20.2h-3.4zm-8.4 0h3.4v20.2h-3.4zm-44.8 8v3.4h-18v-3.3zm39.3 0v3.4h-18v-3.3z'/%3e %3cpath d='M258.9 152.3h3.4v11.3h-3.4z'/%3e %3cpath d='M258.9 152.3h3.4v11.3h-3.4z'/%3e %3cpath d='M258.9 152.3h3.4v11.3h-3.4zm-39.3 0h3.3v11.3h-3.3zm28.8 0h3.4v11.3h-3.4zm-14.3 0h3.4v11.3H234z'/%3e %3cpath d='M250.8 160.2v3.4h-15.2v-3.4zm1-8.7v3.3H242v-3.3z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M300.7 143.4h49v3.4h-49zm7.3 17h3.4v3.2H308zm41.9-.2v3.4H340v-3.4zm5.3-16.8h3.3v20.2h-3.3z'/%3e %3cpath d='M374.7 160.2v3.4h-18.6v-3.4zm-34.6-7.9h3.4v11.3H340z'/%3e %3cpath d='M372 143.4h3.3v20.2H372zm-8.5 0h3.4v20.2h-3.4zm-44.8 8v3.4h-18v-3.3zm39.3 0v3.4h-18v-3.3z'/%3e %3cpath d='M340 152.3h3.5v11.3H340z'/%3e %3cpath d='M340 152.3h3.5v11.3H340z'/%3e %3cpath d='M340 152.3h3.5v11.3H340zm-39.2 0h3.4v11.3h-3.4zm28.8 0h3.4v11.3h-3.4zm-14.3 0h3.4v11.3h-3.4z'/%3e %3cpath d='M332 160.2v3.4h-15.2v-3.4zm1-8.7v3.3h-9.6v-3.3z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M381.4 143.4h49v3.4h-49zm7.3 17h3.4v3.2h-3.4zm42-.2v3.4h-9.9v-3.4zm5.2-16.8h3.4v20.2h-3.4z'/%3e %3cpath d='M455.4 160.2v3.4h-18.6v-3.4zm-34.6-7.9h3.4v11.3h-3.4z'/%3e %3cpath d='M452.7 143.4h3.3v20.2h-3.3zm-8.5 0h3.4v20.2h-3.4zm-44.8 8v3.4h-17.9v-3.3zm39.3 0v3.4h-17.9v-3.3z'/%3e %3cpath d='M420.8 152.3h3.4v11.3h-3.4z'/%3e %3cpath d='M420.8 152.3h3.4v11.3h-3.4z'/%3e %3cpath d='M420.8 152.3h3.4v11.3h-3.4zm-39.3 0h3.4v11.3h-3.4zm28.8 0h3.4v11.3h-3.4zm-14.3 0h3.4v11.3h-3.3z'/%3e %3cpath d='M412.7 160.2v3.4h-15.1v-3.4zm1-8.7v3.3H404v-3.3z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M462.2 143.4h49v3.4h-49zm7.3 17h3.4v3.2h-3.4zm41.9-.2v3.4h-9.8v-3.4zm5.2-16.8h3.4v20.2h-3.4z'/%3e %3cpath d='M536.2 160.2v3.4h-18.6v-3.4zm-34.7-7.9h3.4v11.3h-3.4z'/%3e %3cpath d='M533.4 143.4h3.4v20.2h-3.4zm-8.4 0h3.3v20.2H525zm-44.8 8v3.4h-18v-3.3zm39.3 0v3.4h-18v-3.3z'/%3e %3cpath d='M501.6 152.3h3.3v11.3h-3.3z'/%3e %3cpath d='M501.6 152.3h3.3v11.3h-3.3z'/%3e %3cpath d='M501.6 152.3h3.3v11.3h-3.3zm-39.4 0h3.4v11.3h-3.4zm28.9 0h3.3v11.3h-3.3zm-14.3 0h3.4v11.3h-3.4z'/%3e %3cpath d='M493.4 160.2v3.4h-15.1v-3.4zm1-8.7v3.3h-9.6v-3.3z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M543.4 143.4h49v3.4h-49zm7.3 17h3.4v3.2h-3.4zm41.9-.2v3.4h-9.8v-3.4zm5.2-16.8h3.4v20.2h-3.4z'/%3e %3cpath d='M617.4 160.2v3.4h-18.6v-3.4zm-34.6-7.9h3.3v11.3h-3.3z'/%3e %3cpath d='M614.6 143.4h3.4v20.2h-3.4zm-8.4 0h3.3v20.2h-3.3zm-44.8 8v3.4h-18v-3.3zm39.3 0v3.4h-18v-3.3z'/%3e %3cpath d='M582.8 152.3h3.3v11.3h-3.3z'/%3e %3cpath d='M582.8 152.3h3.3v11.3h-3.3z'/%3e %3cpath d='M582.8 152.3h3.3v11.3h-3.3zm-39.3 0h3.3v11.3h-3.3zm28.8 0h3.4v11.3h-3.4zm-14.3 0h3.4v11.3H558z'/%3e %3cpath d='M574.6 160.2v3.4h-15.1v-3.4zm1-8.7v3.3H566v-3.3z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M-183.8 143.4h49v3.4h-49zm7.3 17h3.4v3.2h-3.4zm42-.2v3.4h-9.9v-3.4zm5.2-16.8h3.4v20.2h-3.4z'/%3e %3cpath d='M-109.8 160.2v3.4h-18.6v-3.4zm-34.6-7.9h3.4v11.3h-3.4z'/%3e %3cpath d='M-112.5 143.4h3.3v20.2h-3.3zm-8.5 0h3.4v20.2h-3.4zm-44.8 8v3.4h-17.9v-3.3zm39.3 0v3.4h-17.9v-3.3z'/%3e %3cpath d='M-144.4 152.3h3.4v11.3h-3.4z'/%3e %3cpath d='M-144.4 152.3h3.4v11.3h-3.4z'/%3e %3cpath d='M-144.4 152.3h3.4v11.3h-3.4zm-39.3 0h3.4v11.3h-3.4zm28.8 0h3.4v11.3h-3.4zm-14.3 0h3.4v11.3h-3.4z'/%3e %3cpath d='M-152.5 160.2v3.4h-15.2v-3.4zm1-8.7v3.3h-9.6v-3.3z'/%3e %3c/g%3e %3cpath fill='%23d90000' d='M-68.8 339.5h6V350h-6zm160.5 0h6V350h-6zm-283.7 0h6V350h-6zm81.5 0h6V350h-6zm80.9 0h6V350h-6zm40 0h6V350h-6zm40.9 0h6V350h-6zm80.4 0h6V350h-6zm203 0h6.1V350h-6zm-162.1 0h6V350h-6zm40 0h6V350h-6zm40.5 0h6V350h-6zm40.4 0h6V350h-6zm323.2 0h6V350h-6zm-242.7 0h6V350h-6zm40.8 0h6V350h-6zm41.3 0h6V350h-6zm38.8 0h6V350h-6zm41.3 0h6V350h-6zm40.4 0h6V350h-6zm119.7 0h6V350h-6zm-38.8 0h6V350h-6zm-808.9 0h6V350h-6z'/%3e %3cpath fill='%23239e3f' d='M-68.8 162.6h6v10.5h-6zm160.5 0h6v10.5h-6zm-283.7 0h6v10.5h-6zm81.5 0h6v10.5h-6zm80.9 0h6v10.5h-6zm40 0h6v10.5h-6zm40.9 0h6v10.5h-6zm80.4 0h6v10.5h-6zm203 0h6.1v10.5h-6zm-162.1 0h6v10.5h-6zm40 0h6v10.5h-6zm40.5 0h6v10.5h-6zm40.4 0h6v10.5h-6zm323.2 0h6v10.5h-6zm-242.7 0h6v10.5h-6zm40.8 0h6v10.5h-6zm41.3 0h6v10.5h-6zm38.8 0h6v10.5h-6zm41.3 0h6v10.5h-6zm40.4 0h6v10.5h-6zm119.7 0h6v10.5h-6zm-38.8 0h6v10.5h-6zm-808.9 0h6v10.5h-6z'/%3e %3cg fill='%23da0000'%3e %3cpath d='M279.8 197.5c8.4 10.4 34.5 67.6-15.7 105.2-23.7 17.8-9 18.6-8.3 21.6 38-20.1 50.3-47.5 50-72-.2-24.4-13.2-46-26-54.8z'/%3e %3cpath d='M284.8 194.8a73.3 73.3 0 0 1 15.7 112.4c27.2-6 62-86.4-15.7-112.4zm-57.6 0a73.3 73.3 0 0 0-15.6 112.4c-27.3-6-62-86.4 15.6-112.4z'/%3e %3cpath d='M232.2 197.5c-8.4 10.4-34.5 67.6 15.7 105.2 23.6 17.8 9 18.6 8.3 21.6-38-20.1-50.3-47.5-50-72 .2-24.4 13.2-46 26-54.8z'/%3e %3cpath d='M304.2 319.1c-14.9.2-33.6-2-47.5-9.3 2.3 4.5 4.2 7.3 6.5 11.7 13.2 1.3 31.5 2.8 41-2.4zm-95 0c14.9.2 33.6-2 47.5-9.3-2.3 4.5-4.2 7.3-6.5 11.7-13.2 1.3-31.5 2.8-41-2.4zm27.3-138.7c3 8 10.9 9.2 19.3 4.5 6.2 3.6 15.7 3.9 19-4.1 2.5 19.8-18.3 15-19 11.2-7.8 7.5-22.2 3.2-19.3-11.6z'/%3e %3cpath d='m256.4 331.6 7.8-9 1.1-120.1-9.3-8.2-9.3 7.8 1.9 121 7.8 8.5z'/%3e %3c/g%3e %3c/g%3e%3c/svg%3e";

var img = "data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' id='flag-icons-us' viewBox='0 0 640 480'%3e %3cg fill-rule='evenodd'%3e %3cg stroke-width='1pt'%3e %3cpath fill='%23bd3d44' d='M0 0h912v37H0zm0 73.9h912v37H0zm0 73.8h912v37H0zm0 73.8h912v37H0zm0 74h912v36.8H0zm0 73.7h912v37H0zM0 443h912V480H0z'/%3e %3cpath fill='white' d='M0 37h912v36.9H0zm0 73.8h912v36.9H0zm0 73.8h912v37H0zm0 73.9h912v37H0zm0 73.8h912v37H0zm0 73.8h912v37H0z'/%3e %3c/g%3e %3cpath fill='%23192f5d' d='M0 0h364.8v258.5H0z'/%3e %3cpath fill='white' d='m30.4 11 3.4 10.3h10.6l-8.6 6.3 3.3 10.3-8.7-6.4-8.6 6.3L25 27.6l-8.7-6.3h10.9zm60.8 0 3.3 10.3h10.8l-8.7 6.3 3.2 10.3-8.6-6.4-8.7 6.3 3.3-10.2-8.6-6.3h10.6zm60.8 0 3.3 10.3H166l-8.6 6.3 3.3 10.3-8.7-6.4-8.7 6.3 3.3-10.2-8.7-6.3h10.8zm60.8 0 3.3 10.3h10.8l-8.7 6.3 3.3 10.3-8.7-6.4-8.7 6.3 3.4-10.2-8.8-6.3h10.7zm60.8 0 3.3 10.3h10.7l-8.6 6.3 3.3 10.3-8.7-6.4-8.7 6.3 3.3-10.2-8.6-6.3h10.7zm60.8 0 3.3 10.3h10.8l-8.8 6.3 3.4 10.3-8.7-6.4-8.7 6.3 3.4-10.2-8.8-6.3h10.8zM60.8 37l3.3 10.2H75l-8.7 6.2 3.2 10.3-8.5-6.3-8.7 6.3 3.1-10.3-8.4-6.2h10.7zm60.8 0 3.4 10.2h10.7l-8.8 6.2 3.4 10.3-8.7-6.3-8.7 6.3 3.3-10.3-8.7-6.2h10.8zm60.8 0 3.3 10.2h10.8l-8.7 6.2 3.3 10.3-8.7-6.3-8.7 6.3 3.3-10.3-8.6-6.2H179zm60.8 0 3.4 10.2h10.7l-8.8 6.2 3.4 10.3-8.7-6.3-8.6 6.3 3.2-10.3-8.7-6.2H240zm60.8 0 3.3 10.2h10.8l-8.7 6.2 3.3 10.3-8.7-6.3-8.7 6.3 3.3-10.3-8.6-6.2h10.7zM30.4 62.6l3.4 10.4h10.6l-8.6 6.3 3.3 10.2-8.7-6.3-8.6 6.3L25 79.3 16.3 73h10.9zm60.8 0L94.5 73h10.8l-8.7 6.3 3.2 10.2-8.6-6.3-8.7 6.3 3.3-10.3-8.6-6.3h10.6zm60.8 0 3.3 10.3H166l-8.6 6.3 3.3 10.2-8.7-6.3-8.7 6.3 3.3-10.3-8.7-6.3h10.8zm60.8 0 3.3 10.3h10.8l-8.7 6.3 3.3 10.2-8.7-6.3-8.7 6.3 3.4-10.3-8.8-6.3h10.7zm60.8 0 3.3 10.3h10.7l-8.6 6.3 3.3 10.2-8.7-6.3-8.7 6.3 3.3-10.3-8.6-6.3h10.7zm60.8 0 3.3 10.3h10.8l-8.8 6.3 3.4 10.2-8.7-6.3-8.7 6.3 3.4-10.3-8.8-6.3h10.8zM60.8 88.6l3.3 10.2H75l-8.7 6.3 3.3 10.3-8.7-6.4-8.7 6.3 3.3-10.2-8.6-6.3h10.7zm60.8 0 3.4 10.2h10.7l-8.8 6.3 3.4 10.3-8.7-6.4-8.7 6.3 3.3-10.2-8.7-6.3h10.8zm60.8 0 3.3 10.2h10.8l-8.7 6.3 3.3 10.3-8.7-6.4-8.7 6.3 3.3-10.2-8.6-6.3H179zm60.8 0 3.4 10.2h10.7l-8.7 6.3 3.3 10.3-8.7-6.4-8.6 6.3 3.2-10.2-8.7-6.3H240zm60.8 0 3.3 10.2h10.8l-8.7 6.3 3.3 10.3-8.7-6.4-8.7 6.3 3.3-10.2-8.6-6.3h10.7zM30.4 114.5l3.4 10.2h10.6l-8.6 6.3 3.3 10.3-8.7-6.4-8.6 6.3L25 131l-8.7-6.3h10.9zm60.8 0 3.3 10.2h10.8l-8.7 6.3 3.2 10.2-8.6-6.3-8.7 6.3 3.3-10.2-8.6-6.3h10.6zm60.8 0 3.3 10.2H166l-8.6 6.3 3.3 10.3-8.7-6.4-8.7 6.3 3.3-10.2-8.7-6.3h10.8zm60.8 0 3.3 10.2h10.8l-8.7 6.3 3.3 10.3-8.7-6.4-8.7 6.3 3.4-10.2-8.8-6.3h10.7zm60.8 0 3.3 10.2h10.7L279 131l3.3 10.3-8.7-6.4-8.7 6.3 3.3-10.2-8.6-6.3h10.7zm60.8 0 3.3 10.2h10.8l-8.8 6.3 3.4 10.3-8.7-6.4-8.7 6.3L329 131l-8.8-6.3h10.8zM60.8 140.3l3.3 10.3H75l-8.7 6.2 3.3 10.3-8.7-6.4-8.7 6.4 3.3-10.3-8.6-6.3h10.7zm60.8 0 3.4 10.3h10.7l-8.8 6.2 3.4 10.3-8.7-6.4-8.7 6.4 3.3-10.3-8.7-6.3h10.8zm60.8 0 3.3 10.3h10.8l-8.7 6.2 3.3 10.3-8.7-6.4-8.7 6.4 3.3-10.3-8.6-6.3H179zm60.8 0 3.4 10.3h10.7l-8.7 6.2 3.3 10.3-8.7-6.4-8.6 6.4 3.2-10.3-8.7-6.3H240zm60.8 0 3.3 10.3h10.8l-8.7 6.2 3.3 10.3-8.7-6.4-8.7 6.4 3.3-10.3-8.6-6.3h10.7zM30.4 166.1l3.4 10.3h10.6l-8.6 6.3 3.3 10.1-8.7-6.2-8.6 6.2 3.2-10.2-8.7-6.3h10.9zm60.8 0 3.3 10.3h10.8l-8.7 6.3 3.3 10.1-8.7-6.2-8.7 6.2 3.4-10.2-8.7-6.3h10.6zm60.8 0 3.3 10.3H166l-8.6 6.3 3.3 10.1-8.7-6.2-8.7 6.2 3.3-10.2-8.7-6.3h10.8zm60.8 0 3.3 10.3h10.8l-8.7 6.3 3.3 10.1-8.7-6.2-8.7 6.2 3.4-10.2-8.8-6.3h10.7zm60.8 0 3.3 10.3h10.7l-8.6 6.3 3.3 10.1-8.7-6.2-8.7 6.2 3.3-10.2-8.6-6.3h10.7zm60.8 0 3.3 10.3h10.8l-8.8 6.3 3.4 10.1-8.7-6.2-8.7 6.2 3.4-10.2-8.8-6.3h10.8zM60.8 192l3.3 10.2H75l-8.7 6.3 3.3 10.3-8.7-6.4-8.7 6.3 3.3-10.2-8.6-6.3h10.7zm60.8 0 3.4 10.2h10.7l-8.8 6.3 3.4 10.3-8.7-6.4-8.7 6.3 3.3-10.2-8.7-6.3h10.8zm60.8 0 3.3 10.2h10.8l-8.7 6.3 3.3 10.3-8.7-6.4-8.7 6.3 3.3-10.2-8.6-6.3H179zm60.8 0 3.4 10.2h10.7l-8.7 6.3 3.3 10.3-8.7-6.4-8.6 6.3 3.2-10.2-8.7-6.3H240zm60.8 0 3.3 10.2h10.8l-8.7 6.3 3.3 10.3-8.7-6.4-8.7 6.3 3.3-10.2-8.6-6.3h10.7zM30.4 217.9l3.4 10.2h10.6l-8.6 6.3 3.3 10.2-8.7-6.3-8.6 6.3 3.2-10.3-8.7-6.3h10.9zm60.8 0 3.3 10.2h10.8l-8.7 6.3 3.3 10.2-8.7-6.3-8.7 6.3 3.4-10.3-8.7-6.3h10.6zm60.8 0 3.3 10.2H166l-8.4 6.3 3.3 10.2-8.7-6.3-8.7 6.3 3.3-10.3-8.7-6.3h10.8zm60.8 0 3.3 10.2h10.8l-8.7 6.3 3.3 10.2-8.7-6.3-8.7 6.3 3.4-10.3-8.8-6.3h10.7zm60.8 0 3.3 10.2h10.7l-8.6 6.3 3.3 10.2-8.7-6.3-8.7 6.3 3.3-10.3-8.6-6.3h10.7zm60.8 0 3.3 10.2h10.8l-8.8 6.3 3.4 10.2-8.7-6.3-8.7 6.3 3.4-10.3-8.8-6.3h10.8z'/%3e %3c/g%3e%3c/svg%3e";

var countries = [
    {
        title: 'IR',
        dialCode: '98',
        mask: '(...) ... ....',
        flag: img$1,
    },
    {
        title: 'AE',
        dialCode: '971',
        mask: '. ... ....',
        flag: img$2,
    },
    {
        title: 'US',
        dialCode: '1',
        mask: '... ... ....',
        flag: img,
    },
];

var StylesImage = styles.styled('img')({
    borderRadius: 4,
    height: 22,
    width: 28
});
var MobileInput = /** @class */ (function (_super) {
    __extends(MobileInput, _super);
    function MobileInput() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            value: _this.props.defaultValue || null,
            error: false,
            country: countries[0],
        };
        _this.onChange = function (event) {
            _this.normalizeValue(event.target.value);
        };
        _this.onClick = function (event) {
            clearTimeout(_this.validationTimeout);
            _this.setState(__assign(__assign({}, _this.state), { error: false }));
            _this.normalizeValue(_this.state.value);
        };
        _this.normalizeValue = function (value) { return __awaiter(_this, void 0, void 0, function () {
            var pattern, pureValue, maskedValues, valueForLength;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!value)
                            return [2 /*return*/, this.setValue(null, true)];
                        value = value.replace(/^0/, '');
                        pattern = this.state.country.mask;
                        pureValue = value.replace(/[^0-9]/g, '');
                        maskedValues = mask(pureValue, pattern, '_');
                        return [4 /*yield*/, this.setValue(pureValue ? maskedValues : null, true)];
                    case 1:
                        _a.sent();
                        valueForLength = maskedValues.match(/.*[0-9]/);
                        if (this.inputRef && valueForLength) {
                            this.inputRef.selectionStart = this.inputRef.selectionEnd = valueForLength[0].length;
                        }
                        return [2 /*return*/];
                }
            });
        }); };
        _this.onChangeCountry = function (event) { return __awaiter(_this, void 0, void 0, function () {
            var dialCode, country;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        dialCode = event.target.value;
                        country = countries.find(function (c) { return c.dialCode === dialCode; });
                        if (!country) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.setState(__assign(__assign({}, this.state), { country: country }))];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        if (this.state.value && country) {
                            this.normalizeValue(this.state.value);
                        }
                        return [2 /*return*/];
                }
            });
        }); };
        _this.click = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.click();
        };
        _this.focus = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.focus();
        };
        _this.blur = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.blur();
        };
        return _this;
    }
    MobileInput.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        switch (true) {
            case this.state.value !== nextState.value:
            case this.state.error !== nextState.error:
            case this.state.country.dialCode !== nextState.country.dialCode:
            case this.props.label !== nextProps.label:
                // case this.props.variant !== this.props.variant:
                return true;
            default: return false;
        }
    };
    MobileInput.prototype.setValue = function (value, internalSet) {
        if (internalSet === void 0) { internalSet = false; }
        return __awaiter(this, void 0, void 0, function () {
            var splits, dialCode_1, country, setStatePromise;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (value === this.state.value)
                            return [2 /*return*/, Promise.resolve()];
                        if (!(value && !internalSet)) return [3 /*break*/, 4];
                        splits = value.split('-');
                        if (!(splits.length > 1)) return [3 /*break*/, 3];
                        dialCode_1 = splits[0].replace(/[^0-9]/g, '');
                        country = countries.find(function (c) { return c.dialCode === dialCode_1; });
                        if (!country) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.setState(__assign(__assign({}, this.state), { country: country }))];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/, this.normalizeValue(splits[1])];
                    case 3: return [2 /*return*/, this.normalizeValue(value)];
                    case 4: return [4 /*yield*/, this.setState(__assign(__assign({}, this.state), { value: value }))];
                    case 5:
                        setStatePromise = _a.sent();
                        if (!(typeof this.props._call_parent_for_update === "function")) return [3 /*break*/, 7];
                        return [4 /*yield*/, this.props._call_parent_for_update()];
                    case 6:
                        _a.sent();
                        _a.label = 7;
                    case 7:
                        if (!(typeof this.props.onChangeValue === "function")) return [3 /*break*/, 9];
                        return [4 /*yield*/, this.props.onChangeValue(value)];
                    case 8:
                        _a.sent();
                        _a.label = 9;
                    case 9: return [2 /*return*/, setStatePromise];
                }
            });
        });
    };
    MobileInput.prototype.getValue = function () {
        if (!this.state.value)
            return null;
        var value = this.state.value.replace(/[^0-9]/g, '');
        return '+' + this.state.country.dialCode + '-' + value;
    };
    MobileInput.prototype.clear = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.setValue(this.props.defaultValue || null, true)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    MobileInput.prototype.validation = function () {
        var _this = this;
        var _a;
        var matchValue = (_a = this.state.value) === null || _a === void 0 ? void 0 : _a.match(/.*[0-9]/);
        var isValid = matchValue && (matchValue[0].length === this.state.country.mask.length);
        if (!isValid && this.props.required) {
            clearTimeout(this.validationTimeout);
            this.setState(__assign(__assign({}, this.state), { error: true }));
            this.validationTimeout = setTimeout(function () {
                _this.setState(__assign(__assign({}, _this.state), { error: false }));
            }, 3000);
            return false;
        }
        return true;
    };
    MobileInput.prototype.render = function () {
        var _this = this;
        var _a = this.props; _a.defaultValue; _a.onChangeValue; _a.visible; _a._call_parent_for_update; var restProps = __rest(_a, ["defaultValue", "onChangeValue", "visible", "_call_parent_for_update"]);
        var isOutlined = this.props.variant === "outlined";
        var inputWidth = 207;
        switch (this.props.variant) {
            case "outlined":
                inputWidth = 235;
                break;
            case "filled":
                inputWidth = 231;
                break;
        }
        return (React__default["default"].createElement(material.Box, { sx: {
                display: 'inline-flex',
                alignItems: 'flex-end',
                width: this.props.fullWidth ? '100%' : inputWidth,
                position: 'relative'
            } },
            React__default["default"].createElement(material.Select, { value: this.state.country.dialCode, onChange: this.onChangeCountry, variant: "standard", margin: 'none', sx: {
                    width: '65px',
                    position: 'absolute',
                    zIndex: 2,
                    left: (isOutlined ? '8px' : 0),
                    top: (isOutlined ? '5px' : '18px'),
                    bottom: 2
                }, renderValue: function (value) {
                    return React__default["default"].createElement(material.Typography, { paddingLeft: '8px' },
                        "+",
                        value);
                }, disableUnderline: true }, countries.map(function (country, index) {
                return (React__default["default"].createElement(material.MenuItem, { key: index, value: country.dialCode, sx: {
                        display: 'flex',
                        alignItems: 'center',
                        justifyContent: 'space-between',
                        minWidth: '100px',
                        paddingRight: '8px',
                        paddingLeft: '8px'
                    } },
                    React__default["default"].createElement(material.Typography, { display: 'inline' },
                        "+",
                        country.dialCode),
                    React__default["default"].createElement(StylesImage, { src: country.flag })));
            })),
            React__default["default"].createElement(TextField__default["default"], __assign({}, restProps, { variant: this.props.variant || "standard", error: this.state.error, onChange: this.onChange, onClick: this.onClick, value: this.state.value || '', inputRef: function (el) { return _this.inputRef = el; }, InputProps: {
                    sx: { width: this.props.fullWidth ? '100%' : inputWidth },
                    startAdornment: (React__default["default"].createElement(material.InputAdornment, { position: 'start' },
                        React__default["default"].createElement(material.Box, { ml: '56px' })))
                } }))));
    };
    return MobileInput;
}(React.Component));

var NumberInput = /** @class */ (function (_super) {
    __extends(NumberInput, _super);
    function NumberInput() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            value: _this.props.defaultValue || null,
            error: false
        };
        _this.onChange = function (event) {
            var value = isNaN(parseInt(event.target.value, 10)) ? null : parseInt(event.target.value, 10);
            if (_this.props.formatter && typeof _this.props.formatter === "function") {
                var formattedValue = _this.props.formatter(value);
                if (formattedValue !== undefined) {
                    value = formattedValue;
                }
            }
            _this.setValue(value);
        };
        _this.onClick = function (event) {
            clearTimeout(_this.validationTimeout);
            _this.setState(__assign(__assign({}, _this.state), { error: false }));
        };
        _this.click = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.click();
        };
        _this.focus = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.focus();
        };
        _this.blur = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.blur();
        };
        return _this;
    }
    NumberInput.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        switch (true) {
            case this.state.value !== nextState.value:
            case this.state.error !== nextState.error:
            case this.props.label !== nextProps.label:
                return true;
            default: return false;
        }
    };
    NumberInput.prototype.setValue = function (value) {
        return __awaiter(this, void 0, void 0, function () {
            var setStatePromise;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (value === this.state.value)
                            return [2 /*return*/, Promise.resolve()];
                        return [4 /*yield*/, this.setState(__assign(__assign({}, this.state), { value: value }))];
                    case 1:
                        setStatePromise = _a.sent();
                        if (!(typeof this.props._call_parent_for_update === "function")) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.props._call_parent_for_update()];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        if (!(typeof this.props.onChangeValue === "function")) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.props.onChangeValue(value)];
                    case 4:
                        _a.sent();
                        _a.label = 5;
                    case 5: return [2 /*return*/, setStatePromise];
                }
            });
        });
    };
    NumberInput.prototype.getValue = function () {
        return checkValue(this.state.value) ? this.state.value : null;
    };
    NumberInput.prototype.clear = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.setValue(checkValue(this.props.defaultValue) ? this.props.defaultValue : null)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    NumberInput.prototype.validation = function () {
        var _this = this;
        if (!checkValue(this.state.value) && this.props.required) {
            clearTimeout(this.validationTimeout);
            this.setState(__assign(__assign({}, this.state), { error: true }));
            this.validationTimeout = setTimeout(function () {
                _this.setState(__assign(__assign({}, _this.state), { error: false }));
            }, 3000);
            return false;
        }
        return true;
    };
    NumberInput.prototype.render = function () {
        var _this = this;
        var _a = this.props; _a.onChangeValue; _a.defaultValue; _a.visible; _a._call_parent_for_update; var restProps = __rest(_a, ["onChangeValue", "defaultValue", "visible", "_call_parent_for_update"]);
        return React__default["default"].createElement(TextField__default["default"], __assign({}, restProps, { variant: this.props.variant || "standard", error: this.state.error, onChange: this.onChange, onClick: this.onClick, value: checkValue(this.state.value) ? this.state.value : "", inputRef: function (el) { return _this.inputRef = el; } }));
    };
    return NumberInput;
}(React.Component));

var OtpInput = /** @class */ (function (_super) {
    __extends(OtpInput, _super);
    function OtpInput() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            value: _this.props.defaultValue || null,
            error: false,
            isInputFocused: false
        };
        _this.onChange = function (event) {
            var value = event.target.value.replace(/[^0-9]/g, '');
            if (_this.props.formatter && typeof _this.props.formatter === "function") {
                var formattedValue = _this.props.formatter(value);
                if (formattedValue !== undefined) {
                    value = formattedValue;
                }
            }
            _this.setValue(value || null);
        };
        _this.onClick = function (event) {
            var _a;
            clearTimeout(_this.validationTimeout);
            _this.setState(__assign(__assign({}, _this.state), { error: false, isInputFocused: true }));
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.focus();
        };
        _this.onBlur = function () {
            _this.setState(__assign(__assign({}, _this.state), { isInputFocused: false }));
        };
        _this.click = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.click();
        };
        _this.focus = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.focus();
        };
        _this.blur = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.blur();
        };
        return _this;
    }
    OtpInput.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        switch (true) {
            case this.state.value !== nextState.value:
            case this.state.error !== nextState.error:
            case this.state.isInputFocused !== nextState.isInputFocused:
                return true;
            default: return false;
        }
    };
    OtpInput.prototype.componentDidMount = function () {
        var _a;
        if (this.props.autoFocus) {
            this.setState(__assign(__assign({}, this.state), { isInputFocused: true }));
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.focus();
        }
    };
    OtpInput.prototype.setValue = function (value) {
        return __awaiter(this, void 0, void 0, function () {
            var setStatePromise;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (value === this.state.value)
                            return [2 /*return*/, Promise.resolve()];
                        return [4 /*yield*/, this.setState(__assign(__assign({}, this.state), { value: value }))];
                    case 1:
                        setStatePromise = _a.sent();
                        if (!(typeof this.props._call_parent_for_update === "function")) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.props._call_parent_for_update()];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        if (!(typeof this.props.onChangeValue === "function")) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.props.onChangeValue(value)];
                    case 4:
                        _a.sent();
                        _a.label = 5;
                    case 5: return [2 /*return*/, setStatePromise];
                }
            });
        });
    };
    OtpInput.prototype.getValue = function () {
        return this.state.value || null;
    };
    OtpInput.prototype.clear = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.setValue(this.props.defaultValue || null)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    OtpInput.prototype.validation = function () {
        var _this = this;
        if (!this.state.value || this.state.value.length < (this.props.digits || 4) && this.props.required) {
            clearTimeout(this.validationTimeout);
            this.setState(__assign(__assign({}, this.state), { error: true }));
            this.validationTimeout = setTimeout(function () {
                _this.setState(__assign(__assign({}, _this.state), { error: false }));
            }, 3000);
            return false;
        }
        return true;
    };
    OtpInput.prototype.render = function () {
        var _this = this;
        var _a;
        var settings = {
            digits: this.props.digits || 4,
            borderWidth: this.props.borderWidth || 1,
            height: this.props.height || 55,
            width: this.props.width || 34.61,
            spaceBetween: this.props.spaceBetween || 8,
            borderRadius: this.props.borderRadius || 4,
            emptyColor: this.props.emptyColor || "#0000003b",
            focusColor: this.props.focusColor || "#1976d2",
            completeColor: this.props.completeColor || "#68b36b",
            fontWeight: this.props.fontWeight || 400,
            fontSize: this.props.fontSize || 23,
            color: this.props.color || '#323232'
        };
        var boxes = Array.from(Array(settings.digits).keys());
        var values = ((_a = this.state.value) === null || _a === void 0 ? void 0 : _a.split('')) || [];
        return (React__default["default"].createElement(React.Fragment, null,
            React__default["default"].createElement(material.Box, { sx: {
                    width: (settings.width * settings.digits) + ((settings.borderWidth * 2) * settings.digits) + (settings.spaceBetween * (settings.digits - 1)),
                    display: 'inline-block',
                    verticalAlign: "top",
                    position: 'relative',
                } },
                React__default["default"].createElement(material.Box, { onClick: this.onClick, sx: {
                        display: 'flex',
                        alignItems: 'center',
                        justifyContent: 'space-between',
                    } },
                    React__default["default"].createElement("input", { autoFocus: this.props.autoFocus, style: { position: 'absolute', zIndex: -1, opacity: 0 }, onChange: this.onChange, onBlur: this.onBlur, value: this.state.value || "", maxLength: settings.digits, inputMode: 'numeric', ref: function (el) { return _this.inputRef = el; } }),
                    boxes.map(function (key) {
                        var value = values[key] || "";
                        return (React__default["default"].createElement(material.Box, { key: key, sx: {
                                height: settings.height,
                                width: settings.width,
                                transition: '0.2s border-color',
                                borderRadius: _this.props.variant !== "outlined" ? 0 : settings.borderRadius + 'px',
                                borderStyle: 'solid',
                                borderWidth: settings.borderWidth + 'px',
                                borderRightWidth: _this.props.variant !== "outlined" ? 0 : settings.borderWidth,
                                borderLeftWidth: _this.props.variant !== "outlined" ? 0 : settings.borderWidth,
                                borderTopWidth: _this.props.variant !== "outlined" ? 0 : settings.borderWidth,
                                borderColor: _this.state.error && !value ? '#d32f2f' :
                                    _this.state.isInputFocused && values.length === key
                                        ? settings.focusColor
                                        : (values.length === settings.digits
                                            ? (_this.state.isInputFocused && (settings.digits === key + 1)
                                                ? settings.focusColor
                                                : settings.completeColor)
                                            : settings.emptyColor),
                            } },
                            React__default["default"].createElement(material.Slide, { in: value ? true : false, direction: "down", appear: false },
                                React__default["default"].createElement(material.Typography, { sx: {
                                        height: '100%',
                                        width: '100%',
                                        display: 'flex',
                                        alignItems: 'center',
                                        justifyContent: 'center',
                                        fontWeight: settings.fontWeight,
                                        fontSize: settings.fontSize,
                                        color: settings.color
                                    } }, value || "☓"))));
                    })))));
    };
    return OtpInput;
}(React.Component));

var PasswordInput = /** @class */ (function (_super) {
    __extends(PasswordInput, _super);
    function PasswordInput() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            value: _this.props.defaultValue || null,
            error: false,
            showPassword: false
        };
        _this.onChange = function (event) {
            var value = event.target.value;
            if (_this.props.formatter && typeof _this.props.formatter === "function") {
                var formattedValue = _this.props.formatter(value);
                if (formattedValue !== undefined) {
                    value = formattedValue;
                }
            }
            _this.setValue(value || null);
        };
        _this.onFocus = function () {
            clearTimeout(_this.validationTimeout);
            _this.setState(__assign(__assign({}, _this.state), { error: false }));
        };
        _this.handleClickShowPassword = function () {
            _this.setState(__assign(__assign({}, _this.state), { showPassword: !_this.state.showPassword }));
        };
        _this.click = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.click();
        };
        _this.focus = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.focus();
        };
        _this.blur = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.blur();
        };
        return _this;
    }
    PasswordInput.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        switch (true) {
            case this.state.value !== nextState.value:
            case this.state.error !== nextState.error:
            case this.state.showPassword !== nextState.showPassword:
            case this.props.label !== nextProps.label:
                return true;
            default: return false;
        }
    };
    PasswordInput.prototype.setValue = function (value) {
        return __awaiter(this, void 0, void 0, function () {
            var setStatePromise;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (value === this.state.value)
                            return [2 /*return*/, Promise.resolve()];
                        return [4 /*yield*/, this.setState(__assign(__assign({}, this.state), { value: value }))];
                    case 1:
                        setStatePromise = _a.sent();
                        if (!(typeof this.props._call_parent_for_update === "function")) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.props._call_parent_for_update()];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        if (!(typeof this.props.onChangeValue === "function")) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.props.onChangeValue(value)];
                    case 4:
                        _a.sent();
                        _a.label = 5;
                    case 5: return [2 /*return*/, setStatePromise];
                }
            });
        });
    };
    PasswordInput.prototype.getValue = function () {
        return this.state.value || null;
    };
    PasswordInput.prototype.clear = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.setValue(this.props.defaultValue || null)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    PasswordInput.prototype.validation = function () {
        var _this = this;
        if (!this.state.value && this.props.required) {
            clearTimeout(this.validationTimeout);
            this.setState(__assign(__assign({}, this.state), { error: true }));
            this.validationTimeout = setTimeout(function () {
                _this.setState(__assign(__assign({}, _this.state), { error: false }));
            }, 3000);
            return false;
        }
        return true;
    };
    PasswordInput.prototype.render = function () {
        var _this = this;
        var _a = this.props; _a.defaultValue; _a.onChangeValue; _a.visible; _a._call_parent_for_update; var restProps = __rest(_a, ["defaultValue", "onChangeValue", "visible", "_call_parent_for_update"]);
        var variantWidth = '207px';
        if (this.props.variant === "outlined")
            variantWidth = "235px";
        if (this.props.variant === "filled")
            variantWidth = "231px";
        var inputWidth = this.props.fullWidth ? '100%' : variantWidth;
        return (React__default["default"].createElement(TextField__default["default"], __assign({}, restProps, { sx: __assign(__assign({}, this.props.sx), { width: inputWidth }), type: this.state.showPassword ? 'text' : 'password', variant: this.props.variant || "standard", error: this.state.error, onChange: this.onChange, onFocus: this.onFocus, value: this.state.value || '', inputRef: function (el) { return _this.inputRef = el; }, InputProps: {
                endAdornment: (React__default["default"].createElement(material.InputAdornment, { position: "end" },
                    React__default["default"].createElement(material.IconButton, { onClick: this.handleClickShowPassword }, this.state.showPassword ? React__default["default"].createElement(iconsMaterial.Visibility, null) : React__default["default"].createElement(iconsMaterial.VisibilityOff, null))))
            } })));
    };
    return PasswordInput;
}(React.Component));

var LoadingComponent = function (props) { return (React__default["default"].createElement(material.Grow, { in: true, timeout: 550 },
    React__default["default"].createElement(material.Box, { sx: { paddingRight: '16px', paddingTop: '4px' } },
        React__default["default"].createElement(material.CircularProgress, { size: 18 })))); };
var SelectInput = /** @class */ (function (_super) {
    __extends(SelectInput, _super);
    function SelectInput() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            value: _this.props.defaultValue || null,
            error: false
        };
        _this.onChange = function (event) {
            var value = event.target.value;
            _this.setValue(value || null);
        };
        _this.onClick = function (event) {
            clearTimeout(_this.validationTimeout);
            _this.setState(__assign(__assign({}, _this.state), { error: false }));
        };
        _this.onOpen = function () {
            clearTimeout(_this.validationTimeout);
            _this.setState(__assign(__assign({}, _this.state), { error: false }));
        };
        _this.click = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.click();
        };
        _this.focus = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.focus();
        };
        _this.blur = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.blur();
        };
        return _this;
    }
    SelectInput.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        switch (true) {
            case this.state.value !== nextState.value:
            case this.state.error !== nextState.error:
            case this.props.options.map(function (i) { return i.value; }).join('@') !== nextProps.options.map(function (i) { return i.value; }).join('@'):
            case this.props.loading !== nextProps.loading:
            case this.props.label !== nextProps.label:
                return true;
            default: return false;
        }
    };
    SelectInput.prototype.componentDidUpdate = function (props) {
        if (this.props.options.map(function (i) { return i.value; }).join('@') !== props.options.map(function (i) { return i.value; }).join('@')) {
            this.setValue(null);
        }
    };
    SelectInput.prototype.setValue = function (value) {
        return __awaiter(this, void 0, void 0, function () {
            var valueToSet, setStatePromise;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (value === this.state.value)
                            return [2 /*return*/, Promise.resolve()];
                        valueToSet = value;
                        return [4 /*yield*/, this.setState(__assign(__assign({}, this.state), { value: valueToSet }))];
                    case 1:
                        setStatePromise = _a.sent();
                        if (!(typeof this.props._call_parent_for_update === "function")) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.props._call_parent_for_update()];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        if (typeof this.props.onChangeValue === "function") {
                            this.props.onChangeValue(value);
                        }
                        return [2 /*return*/, setStatePromise];
                }
            });
        });
    };
    SelectInput.prototype.getValue = function () {
        return this.state.value || null;
    };
    SelectInput.prototype.clear = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.setValue(this.props.defaultValue || null)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    SelectInput.prototype.validation = function () {
        var _this = this;
        if (!this.state.value && this.props.required) {
            clearTimeout(this.validationTimeout);
            this.setState(__assign(__assign({}, this.state), { error: true }));
            this.validationTimeout = setTimeout(function () {
                _this.setState(__assign(__assign({}, _this.state), { error: false }));
            }, 3000);
            return false;
        }
        return true;
    };
    SelectInput.prototype.render = function () {
        var _this = this;
        var _a = this.props; _a.onChangeValue; var variant = _a.variant; _a.visible; var required = _a.required; _a._call_parent_for_update; _a.loading; _a.listSubheaderText; _a.defaultValue; var restProps = __rest(_a, ["onChangeValue", "variant", "visible", "required", "_call_parent_for_update", "loading", "listSubheaderText", "defaultValue"]);
        var variantWidth = '207px';
        if (this.props.variant === "outlined")
            variantWidth = "235px";
        if (this.props.variant === "filled")
            variantWidth = "231px";
        var inputWidth = this.props.fullWidth ? '100%' : variantWidth;
        return (React__default["default"].createElement(material.FormControl, { sx: { width: inputWidth }, variant: variant || "standard", error: this.state.error },
            React__default["default"].createElement(material.InputLabel, { required: required, id: "".concat(this.props.selector + "-select-label") }, this.props.label),
            React__default["default"].createElement(material.Select, __assign({}, restProps, { labelId: "".concat(this.props.selector + "-select-label"), id: "".concat(this.props.selector + "-select-identity"), onOpen: this.onOpen, value: this.state.value || (this.props.multiple ? [] : ""), onChange: this.onChange, disabled: this.props.disabled || this.props.loading, IconComponent: this.props.loading ? LoadingComponent : (this.props.IconComponent || ArrowDropDownIcon__default["default"]), inputRef: function (el) { return _this.inputRef = el; } }), !this.props.options.length ? (React__default["default"].createElement(material.ListSubheader, { sx: { textAlign: 'center' } }, this.props.listSubheaderText || ("Items Not Found"))) : this.props.options.map(function (option, key) { return React__default["default"].createElement(material.MenuItem, { key: key, value: option.value }, option.label); }))));
    };
    return SelectInput;
}(React.Component));

var TextInput = /** @class */ (function (_super) {
    __extends(TextInput, _super);
    function TextInput() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            value: _this.props.defaultValue || null,
            error: false
        };
        _this.onChange = function (event) {
            var value = event.target.value;
            if (_this.props.formatter && typeof _this.props.formatter === "function") {
                var formattedValue = _this.props.formatter(value);
                if (formattedValue !== undefined) {
                    value = formattedValue;
                }
            }
            _this.setValue(value || null);
        };
        _this.onClick = function (event) {
            clearTimeout(_this.validationTimeout);
            _this.setState(__assign(__assign({}, _this.state), { error: false }));
        };
        _this.click = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.click();
        };
        _this.focus = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.focus();
        };
        _this.blur = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.blur();
        };
        return _this;
    }
    TextInput.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        switch (true) {
            case this.state.value !== nextState.value:
            case this.state.error !== nextState.error:
            case this.props.label !== nextProps.label:
            case this.props.label !== nextProps.label:
                return true;
            default: return false;
        }
    };
    TextInput.prototype.setValue = function (value) {
        return __awaiter(this, void 0, void 0, function () {
            var setStatePromise;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (value === this.state.value)
                            return [2 /*return*/, Promise.resolve()];
                        return [4 /*yield*/, this.setState(__assign(__assign({}, this.state), { value: value }))];
                    case 1:
                        setStatePromise = _a.sent();
                        if (!(typeof this.props._call_parent_for_update === "function")) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.props._call_parent_for_update()];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        if (!(typeof this.props.onChangeValue === "function")) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.props.onChangeValue(value)];
                    case 4:
                        _a.sent();
                        _a.label = 5;
                    case 5: return [2 /*return*/, setStatePromise];
                }
            });
        });
    };
    TextInput.prototype.getValue = function () {
        return this.state.value || null;
    };
    TextInput.prototype.clear = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.setValue(this.props.defaultValue || null)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    TextInput.prototype.validation = function () {
        var _this = this;
        if (!this.state.value && this.props.required) {
            clearTimeout(this.validationTimeout);
            this.setState(__assign(__assign({}, this.state), { error: true }));
            this.validationTimeout = setTimeout(function () {
                _this.setState(__assign(__assign({}, _this.state), { error: false }));
            }, 3000);
            return false;
        }
        return true;
    };
    TextInput.prototype.render = function () {
        var _this = this;
        var _a = this.props; _a.defaultValue; _a.onChangeValue; _a.visible; _a.formatter; _a._call_parent_for_update; var restProps = __rest(_a, ["defaultValue", "onChangeValue", "visible", "formatter", "_call_parent_for_update"]);
        return React__default["default"].createElement(TextField__default["default"], __assign({}, restProps, { variant: this.props.variant || "standard", error: this.state.error, onChange: this.onChange, onClick: this.onClick, value: this.state.value || '', inputRef: function (el) { return _this.inputRef = el; } }));
    };
    return TextInput;
}(React.Component));

var TimeInput = /** @class */ (function (_super) {
    __extends(TimeInput, _super);
    function TimeInput() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            value: _this.props.defaultValue || null,
            error: false
        };
        _this.onChange = function (event) {
            var value = event && event.toDate ? event.toDate() : event;
            _this.setValue(value || null);
        };
        _this.onClick = function () {
            clearTimeout(_this.validationTimeout);
            _this.setState(__assign(__assign({}, _this.state), { error: false }));
        };
        _this.click = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.click();
        };
        _this.focus = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.focus();
        };
        _this.blur = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.blur();
        };
        return _this;
    }
    TimeInput.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        switch (true) {
            case this.state.value !== nextState.value:
            case this.state.error !== nextState.error:
            case this.props.label !== nextProps.label:
                return true;
            default: return false;
        }
    };
    TimeInput.prototype.setValue = function (value) {
        return __awaiter(this, void 0, void 0, function () {
            var setStatePromise;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (value === this.state.value)
                            return [2 /*return*/, Promise.resolve()];
                        return [4 /*yield*/, this.setState(__assign(__assign({}, this.state), { value: value }))];
                    case 1:
                        setStatePromise = _a.sent();
                        if (!(typeof this.props._call_parent_for_update === "function")) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.props._call_parent_for_update()];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        if (!(typeof this.props.onChangeValue === "function")) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.props.onChangeValue(value)];
                    case 4:
                        _a.sent();
                        _a.label = 5;
                    case 5: return [2 /*return*/, setStatePromise];
                }
            });
        });
    };
    TimeInput.prototype.getValue = function () {
        return this.state.value || null;
    };
    TimeInput.prototype.clear = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.setValue(this.props.defaultValue || null)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    TimeInput.prototype.validation = function () {
        var _this = this;
        if (!this.state.value && this.props.required) {
            clearTimeout(this.validationTimeout);
            this.setState(__assign(__assign({}, this.state), { error: true }));
            this.validationTimeout = setTimeout(function () {
                _this.setState(__assign(__assign({}, _this.state), { error: false }));
            }, 3000);
            return false;
        }
        return true;
    };
    TimeInput.prototype.render = function () {
        var _this = this;
        var _a = this.props; _a.defaultValue; _a.onChangeValue; var dateAdapter = _a.dateAdapter, variant = _a.variant, required = _a.required; _a.visible; _a._call_parent_for_update; var restProps = __rest(_a, ["defaultValue", "onChangeValue", "dateAdapter", "variant", "required", "visible", "_call_parent_for_update"]);
        return (React__default["default"].createElement(xDatePickers.LocalizationProvider, { dateAdapter: dateAdapter || AdapterDayjs.AdapterDayjs },
            React__default["default"].createElement(xDatePickers.TimePicker, __assign({}, restProps, { ampm: this.props.ampm || false, value: this.state.value, onChange: this.onChange, inputRef: function (el) { return _this.inputRef = el; }, renderInput: function (params) { return (React__default["default"].createElement(TextField__default["default"], __assign({}, params, { inputProps: __assign(__assign({}, params.inputProps), _this.props.inputProps), fullWidth: _this.props.fullWidth || false, variant: variant || "standard", required: required || false, error: _this.state.error, onClick: _this.onClick }))); } }))));
    };
    return TimeInput;
}(React.Component));

var ToggleInput = /** @class */ (function (_super) {
    __extends(ToggleInput, _super);
    function ToggleInput() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            value: checkValue(_this.props.defaultValue) ? (_this.props.defaultValue === undefined ? null : _this.props.defaultValue) : null,
            error: false
        };
        _this.onChange = function (_, value) {
            _this.setValue(checkValue(value) ? value : (_this.props.enforceValueSet ? _this.state.value : null));
        };
        _this.onClick = function (event) {
            clearTimeout(_this.validationTimeout);
            _this.setState(__assign(__assign({}, _this.state), { error: false }));
        };
        _this.click = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.click();
        };
        _this.focus = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.focus();
        };
        _this.blur = function () {
            var _a;
            (_a = _this.inputRef) === null || _a === void 0 ? void 0 : _a.blur();
        };
        return _this;
    }
    ToggleInput.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        switch (true) {
            case this.state.value !== nextState.value:
            case this.state.error !== nextState.error:
            case this.props.label !== nextProps.label:
            case this.props.options.map(function (i) { return i.value; }).join('@') !== nextProps.options.map(function (i) { return i.value; }).join('@'):
                return true;
            default: return false;
        }
    };
    ToggleInput.prototype.setValue = function (value) {
        return __awaiter(this, void 0, void 0, function () {
            var setStatePromise;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (value === this.state.value)
                            return [2 /*return*/, Promise.resolve()];
                        return [4 /*yield*/, this.setState(__assign(__assign({}, this.state), { value: value }))];
                    case 1:
                        setStatePromise = _a.sent();
                        if (!(typeof this.props._call_parent_for_update === "function")) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.props._call_parent_for_update()];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        if (!(typeof this.props.onChangeValue === "function")) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.props.onChangeValue(value)];
                    case 4:
                        _a.sent();
                        _a.label = 5;
                    case 5: return [2 /*return*/, setStatePromise];
                }
            });
        });
    };
    ToggleInput.prototype.getValue = function () {
        return checkValue(this.state.value) ? this.state.value : null;
    };
    ToggleInput.prototype.clear = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.setValue(this.props.defaultValue || null)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    ToggleInput.prototype.validation = function () {
        var _this = this;
        if (!checkValue(this.state.value) && this.props.required) {
            clearTimeout(this.validationTimeout);
            this.setState(__assign(__assign({}, this.state), { error: true }));
            this.validationTimeout = setTimeout(function () {
                _this.setState(__assign(__assign({}, _this.state), { error: false }));
            }, 3000);
            return false;
        }
        return true;
    };
    ToggleInput.prototype.render = function () {
        var _a = this.props; _a.onChangeValue; _a.visible; _a.formatter; _a.defaultValue; _a.label; _a._call_parent_for_update; _a.enforceValueSet; var restProps = __rest(_a, ["onChangeValue", "visible", "formatter", "defaultValue", "label", "_call_parent_for_update", "enforceValueSet"]);
        return (React__default["default"].createElement(material.ToggleButtonGroup, __assign({}, restProps, { color: this.state.error ? 'error' : (this.props.color || "primary"), value: this.state.value, exclusive: this.props.exclusive === false ? false : true, onChange: this.onChange }), this.props.options.map(function (option, key) { return React__default["default"].createElement(material.ToggleButton, { key: "".concat(key, "-").concat(option.value), value: option.value }, option.label); })));
    };
    return ToggleInput;
}(React.Component));

var FormBuilder = /** @class */ (function (_super) {
    __extends(FormBuilder, _super);
    function FormBuilder() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            isMounted: false
        };
        _this.inputRefs = {};
        _this.inputs = {
            text: TextInput,
            number: NumberInput,
            items: ItemsInput,
            custom: CustomInput,
            checkbox: CheckboxInput,
            mobile: MobileInput,
            otp: OtpInput,
            password: PasswordInput,
            select: SelectInput,
            date: DateInput,
            time: TimeInput,
            datetime: DatetimeInput,
            mask: MaskInput,
            file: FileInput,
            autocomplete: AutocompleteInput,
            toggle: ToggleInput,
        };
        _this.defaultValues = null;
        _this.getValues = function (validation) {
            if (validation === void 0) { validation = true; }
            var data = _this.defaultValues || {};
            var invalidInputs = [];
            _this.props.inputs.forEach(function (inputProps) {
                var input = _this.inputRefs[inputProps.selector];
                if (input) {
                    if (validation) {
                        var isValid = input.validation();
                        if ((inputProps.required || inputProps.type === "items" || inputProps.type === "custom") && !isValid) {
                            invalidInputs.push(inputProps);
                        }
                    }
                    var value = input.getValue(validation);
                    if (inputProps.getMutator && typeof inputProps.getMutator === "function") {
                        var mutatedValue = inputProps.getMutator(value);
                        value = mutatedValue !== undefined ? mutatedValue : value;
                    }
                    setToObject(inputProps.selector, value, data);
                }
            });
            return {
                data: data,
                validation: {
                    status: invalidInputs.length < 1,
                    inputs: invalidInputs
                },
            };
        };
        _this.setValues = function (value) { return __awaiter(_this, void 0, void 0, function () {
            var setValues;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.defaultValues = value;
                        setValues = Object.keys(value).map(function (selector) { return __awaiter(_this, void 0, void 0, function () {
                            var valueItem;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        valueItem = value[selector];
                                        return [4 /*yield*/, this.setValue(selector, valueItem)];
                                    case 1: return [2 /*return*/, _a.sent()];
                                }
                            });
                        }); });
                        return [4 /*yield*/, Promise.all(setValues)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        }); };
        _this.clear = function () { return __awaiter(_this, void 0, void 0, function () {
            var clearValues;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        clearValues = Object.keys(this.inputRefs).map(function (selector) { return __awaiter(_this, void 0, void 0, function () {
                            var input;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        input = this.inputRefs[selector];
                                        if (!input) return [3 /*break*/, 2];
                                        return [4 /*yield*/, input.clear()];
                                    case 1:
                                        _a.sent();
                                        _a.label = 2;
                                    case 2: return [2 /*return*/];
                                }
                            });
                        }); });
                        return [4 /*yield*/, Promise.all(clearValues)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        }); };
        _this.lastVisibilityOfInputs = {};
        _this.checkVisibility = function (input) {
            var _a, _b;
            var _c, _d;
            var visible = true;
            if (typeof input.visible === "function") {
                visible = input.visible((_c = _this.getValues(false)) === null || _c === void 0 ? void 0 : _c.data);
            }
            else {
                visible = input.visible;
            }
            var output = visible === true || visible === undefined ? true : false;
            var prev = (_d = _this.lastVisibilityOfInputs[input.selector]) === null || _d === void 0 ? void 0 : _d.now;
            if (prev !== undefined) {
                _this.lastVisibilityOfInputs = __assign(__assign({}, _this.lastVisibilityOfInputs), (_a = {}, _a[input.selector] = { prev: prev, now: output }, _a));
            }
            else {
                _this.lastVisibilityOfInputs = __assign(__assign({}, _this.lastVisibilityOfInputs), (_b = {}, _b[input.selector] = { prev: prev, now: output }, _b));
            }
            return output;
        };
        _this.onUpdateInputs = function () {
            return _this.forceUpdate();
        };
        _this.renderInput = function (input, index) {
            if (!_this.checkVisibility(input))
                return null;
            var wrapper = input.wrapper; input.getMutator; input.setMutator; var props = __rest(input, ["wrapper", "getMutator", "setMutator"]);
            var actions = {
                setValue: function (data) { if (_this.state.isMounted)
                    return _this.inputRefs[input.selector].setValue(data); },
                getValue: function () { if (_this.state.isMounted)
                    return _this.inputRefs[input.selector].getValue(); },
                clear: function () { if (_this.state.isMounted)
                    return _this.inputRefs[input.selector].clear(); },
                click: function () { if (_this.state.isMounted)
                    return _this.inputRefs[input.selector].click(); },
                focus: function () { if (_this.state.isMounted)
                    return _this.inputRefs[input.selector].focus(); },
                blur: function () { if (_this.state.isMounted)
                    return _this.inputRefs[input.selector].blur(); }
            };
            var element = React__default["default"].createElement(_this.inputs[input.type], __assign(__assign({ ref: function (el) { return _this.inputRefs[input.selector] = el; } }, props), { actions: actions, _call_parent_for_update: _this.onUpdateInputs }));
            var output = (React__default["default"].createElement(React.Fragment, { key: index }, wrapper ? wrapper(element, actions) : element));
            return output;
        };
        return _this;
    }
    FormBuilder.prototype.componentDidMount = function () {
        this.setState(__assign(__assign({}, this.state), { isMounted: true }));
    };
    FormBuilder.prototype.componentWillUnmount = function () {
        this.setState(__assign(__assign({}, this.state), { isMounted: false }));
    };
    FormBuilder.prototype.componentDidUpdate = function (prevProps, prevState, snapshot) {
        var _this = this;
        this.props.inputs.forEach(function (item) {
            var _a, _b;
            var prevVisible = (_a = _this.lastVisibilityOfInputs[item.selector]) === null || _a === void 0 ? void 0 : _a.prev;
            var nowVisible = (_b = _this.lastVisibilityOfInputs[item.selector]) === null || _b === void 0 ? void 0 : _b.now;
            if ((prevVisible !== nowVisible) && _this.defaultValues && Object.keys(_this.defaultValues).length) {
                _this.setValue(item.selector, _this.defaultValues[item.selector]);
            }
        });
    };
    FormBuilder.prototype.setObjectValues = function (object, path) {
        if (path === void 0) { path = []; }
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, _i, key, value;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _a = [];
                        for (_b in object)
                            _a.push(_b);
                        _i = 0;
                        _c.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3 /*break*/, 6];
                        key = _a[_i];
                        value = object[key];
                        if (!(typeof value === "object" && !Array.isArray(value))) return [3 /*break*/, 3];
                        path.push(key);
                        return [4 /*yield*/, this.setObjectValues(value, path)];
                    case 2: return [2 /*return*/, _c.sent()];
                    case 3: return [4 /*yield*/, this.setNormalValue(__spreadArray(__spreadArray([], path, true), [key], false).join('.'), value)];
                    case 4: return [2 /*return*/, _c.sent()];
                    case 5:
                        _i++;
                        return [3 /*break*/, 1];
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    FormBuilder.prototype.setNormalValue = function (selector, value) {
        return __awaiter(this, void 0, void 0, function () {
            var regex, keyValueSelectors, input, inputProps, mutatedValue;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        regex = new RegExp('^(' + selector + ')\\[.*\\=.*\\]\\..*');
                        keyValueSelectors = Object.keys(this.inputRefs).filter(function (i) { return regex.test(i); });
                        if (!(Array.isArray(value) && keyValueSelectors.length)) return [3 /*break*/, 2];
                        return [4 /*yield*/, Promise.all(keyValueSelectors.map(function (keyValueSelector) { return __awaiter(_this, void 0, void 0, function () {
                                var valueItem, input, inputProps, mutatedValue;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            valueItem = selectFromObject(keyValueSelector.replace(selector, ''), value);
                                            input = this.inputRefs[keyValueSelector];
                                            if (!input || valueItem === undefined)
                                                return [2 /*return*/, false];
                                            inputProps = this.props.inputs.find(function (i) { return i.selector === keyValueSelector; });
                                            if ((inputProps === null || inputProps === void 0 ? void 0 : inputProps.setMutator) && typeof inputProps.setMutator === "function") {
                                                mutatedValue = inputProps.setMutator(valueItem);
                                                valueItem = mutatedValue !== undefined ? mutatedValue : valueItem;
                                            }
                                            return [4 /*yield*/, input.setValue(valueItem)];
                                        case 1: return [2 /*return*/, _a.sent()];
                                    }
                                });
                            }); }))];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        input = this.inputRefs[selector];
                        if (!(input && value)) return [3 /*break*/, 4];
                        inputProps = this.props.inputs.find(function (i) { return i.selector === selector; });
                        if ((inputProps === null || inputProps === void 0 ? void 0 : inputProps.setMutator) && typeof inputProps.setMutator === "function") {
                            mutatedValue = inputProps.setMutator(value);
                            value = mutatedValue !== undefined ? mutatedValue : value;
                        }
                        return [4 /*yield*/, (input === null || input === void 0 ? void 0 : input.setValue(value))];
                    case 3: return [2 /*return*/, _a.sent()];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    FormBuilder.prototype.setValue = function (selector, value) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(typeof value === "object" && !Array.isArray(value) && !(value instanceof Date))) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.setObjectValues(value, [selector])];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2: return [4 /*yield*/, this.setNormalValue(selector, value)];
                    case 3: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    FormBuilder.prototype.render = function () {
        return !this.state.isMounted ? React__default["default"].createElement(React.Fragment, null) : (React__default["default"].createElement(React.Fragment, null, this.props.inputs.map(this.renderInput)));
    };
    return FormBuilder;
}(React.Component));

exports.FormBuilder = FormBuilder;
//# sourceMappingURL=index.js.map
